<?php
defined('_JEXEC') or die('Restricted access');

class plgCommunityUser_Cv extends JPlugin
{
	function plgCommunityUser_Cv(&$subject, $config)
	{
		parent::__construct($subject, $config);
	}

	function onProfileExtra($user, $params = null, $name)
	{
		//init and prepare some vars
		if($name!='user_cv') return;
			
		$db                 = &JFactory::getDBO();
		$this->uri          = &JFactory::getURI();
		$user 				= JFactory::getUser();
		$itemId 			= $this->params->get('item_itemid');

		$remove_id = JRequest::getInt( 'cv_remove' );
		$user_id =  $user->get('id');
		if( $remove_id ) $this->removeRecord( $db, $remove_id , $user_id);

		$this->uri->delVar('cv_remove');
		if(JRequest::getString( 'task') && JRequest::getString( 'task') == "add_cv")
		$this->AddRecord( $db, $user_id );
		$out_text = '';

		$out_text .= '
		<style>		
		.cv_table {border: 1px solid #ddd;}
		.hidden {display: none;}
		.userCv { border-bottom: 1px solid #ddd; width: 100%; background-color: #FFFFFF;}
		a.removeLink{cursor: pointer;}
		</style>
		';		
		$out_text .= $this->GenJScript();

		if($user->get('id')>0 && (JRequest::getInt('user_id') && $user->get('id')==JRequest::getInt('user_id') || !JRequest::getInt('user_id')))
		{
			$out_text .= '
			<div style="text-align: right;">
			   <img src="'.JURI::root().'plugins/community/cv_images/add.png" alt="'.JText::_('Add new record').'" align="absmiddle">
			   <a href="javascript:void(0);" onClick="cv_showCvForm()" name="write">'.
			JText::_( 'Add new record' ).'</a>
	  	    </div><br>
			<div id="cv" style="display: none; visibility: hidden;">
			';
				
			$this->uri->setVar( 'task', 'add_cv' );
			$out_text .= '
			<form action="'.$this->uri->toString().'" method="post" name="cvForm">
			<table width="100%" class="cv_table" cellpadding="2">';
			$this->uri->delVar('task');
				
			$out_text .= $this->GenForm('add');
				
			$out_text .= '
				<tr>
					<td></td>
					<td>
						<input type="button" value="'.JText::_("Save").'" class="button"
						onClick="validateFormCV();">
					</td>
				</tr>
			</table><br><br>
			</form>
			</div>';
		}
		$out_text .= $this->getUserCVData();

		$ret = new JSCommunityTab();
		$ret->name  = 'jspt_user_cv';
		$ret->title = JText::_("User Work Experience");
		$ret->text  = $out_text;
		return $ret;
	}

	function GenForm( $formTo, $sel = false )
	{
		$out = array();
		$fields[] = "country";
		$list["country"] = $this->GenListCore("country", 0, '', 0, $formTo);
		$fields[]= "region";
		$list[ "region"] = $this->GenListCore("region", 0, '', 1, $formTo);
		$fields[]= "city";
		$list["city"]= $this->GenListCore("city", 0, '', 1, $formTo);
		$fields[] = "company";
		$list["company"] = $this->GenListCore("company", 0, (isset($sel['company']) ? $sel['company'] :''), 1, $formTo);
		$fields[] = "position";
		$list["position"] = $this->GenListCore("position", 0, '', 1, $formTo);
		$fields[]= "begin";
		$list["begin"] = $this->GenListYear("begin",$sel['begin']);

		$list["bmonth"] = $this->GenListMonth("bmonth", $sel['bmonth']);
		$fields[]= "till";
		$list["till"] = $this->GenListYear("till",$sel['till']);

		$list["tmonth"] = $this->GenListMonth("tmonth", $sel['tmonth']);
		$fields[]= "additional";

		for($i=0; $i<3; $i++)
		{
			$parent_val = ($i==0)? ', false, false, "Cv"' : ', document.cvForm.elements["'.$fields[$i-1].'"].value, false, "Cv"';
			$out[] = '
			<tr>
				<td width="100px">'.JText::_(ucfirst($fields[$i])).'</td>
				<td width=90% id="'.$fields[$i].'ListCV">'.$list[$fields[$i]].'</td>
			</tr>
			<tr>
				<td></td>
				<td width="90%">
				<div id="div_'.$fields[$i].'_cv" style="display: none;">
					<input type="text" id="Add_'.$fields[$i].'" class="inputbox" size="50">&nbsp;
					<input type="button" class="button" value="'.JText::_("Add").'" 
					onClick=\' if(this.form.Add_'.$fields[$i].'.value!="") xajax_AddSelectItem("'.$fields[$i].'", this.form.Add_'.$fields[$i].'.value, "'.$fields[$i+1].'" '.$parent_val.');\'>
				</div>
				</td>
			</tr>';
		}

		for($i=3; $i<5; $i++)
		{
			$next = ($i!=4)? $fields[$i+1] : '';
			$out[] = '
			<tr>
				<td width="100px">'.JText::_(ucfirst($fields[$i])).'</td>
				<td width=90% id="'.$fields[$i].'ListCV">'.$list[$fields[$i]].'</td>
			</tr>
			<tr>
				<td></td>
				<td width="90%">
				<div id="div_'.$fields[$i].'_cv" style="display: none;">
					<input type="text" id="Add_'.$fields[$i].'" class="inputbox" size="50">&nbsp;
					<input type="button" class="button" value="'.JText::_("Add").'" 
					onClick=\'RecordExistErrorCV("'.$fields[$i].'", this.form.Add_'.$fields[$i].'.value);
					itemSelectedCoreCV(this.form.'.$fields[$i].'.value, "'.$fields[$i].'", "'.$next.'", "", "add");\'>
				</div>
				</td>
			</tr>';
		}
		for($i=5; $i<7; $i++)
		{
			$out[] = '<tr><td>'.JText::_(ucfirst($fields[$i])).'</td>
			<td id="'.$fields[$i].'List">'.$list[$fields[$i]].' '.$list[substr($fields[$i], 0, 1)."month"].'</td></tr>';
		}
		if($formTo != 'search')
		$out[] = '
			<tr valign="top">
				<td>'.JText::_(ucfirst($fields[7])).'</td>
				<td id="'.$fields[$i].'ListCV">
					<textarea class="inputbox" style="width: 50%" rows="4" name="additional" class="inbox"></textarea>
				</td>
			</tr>';
		return implode($out);
	}

	function GenJScript()
	{
		$script ='
		<script language="JavaScript">	
			var d = document;
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'cvForm').';
		function addCVOption(selectId, txt, val)
		{
			if(txt!="")
			{
		    var objSel = d.cvForm.elements[selectId];
			objSel.options[objSel.options.length-1] = new Option(txt, val, true, true);
			objSel.options[objSel.options.length] = new Option("'.JText::_('Other').'", -1);
			d.cvForm.elements["Add_"+selectId].value="";
			hideAddCV("div_"+selectId+"_cv");
			}
		}
		
		function cv_showCvForm()
		{
			var cvForm 	= document.getElementById("cv");
			var show 	= cvForm.style.display=="none";

			// show the form to calc height
			cvForm.style.display = "block";
			
			
			// Search for slider div
			var slider = cvForm.parentNode;
			
			for (var i = 0; i < 10 && slider; i++)
			{
				if (slider.className && slider.className.match(/jpane-slider/))
				{
					var formHeight 		= cvForm.offsetHeight;
					var sliderHeight	= slider.offsetHeight;
					
					if (show && sliderHeight < formHeight)
						slider.style.height = (sliderHeight + formHeight) + "px";
					else if (sliderHeight > formHeight)
						slider.style.height = (sliderHeight - formHeight) + "px";
					
					break;
				}
				
				slider = slider.parentNode;
			}
			
			/// Show / Hide form
			cvForm.style.display 	= show ? "block" : "none";
			cvForm.style.visibility = show ? "visible" : "hidden";
		}
		
		function itemSelectedCoreCV(val, id, next, sel, formTo)
		{		
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'cvForm').';
				if(val<0) {
					form.elements["Add_"+id].value="";
					showAddCV("div_" + id+"_cv");
					form.elements["Add_" + id].focus( );
					if(next!="") disableCV(next);
				} else if (val==0) {				
					hideAddCV("div_" + id+"_cv");
					if(next!="") disableCV(next);					
				} else {				
					if(next!="") {
					form.elements[next].options[0].text = "'. JText::_("Loading").'...";
					xajax_GetSelectListCoreCv(next, val, sel, formTo);					
					}
					hideAddCV("div_" + id+"_cv");
				}
				if(id == "country") {
					hideAddCV("div_region_cv");
					if(sel=="")form.region.value=0;
					if(sel=="")form.city.value=0;
					disableCV("city"); hideAddCV("div_city_cv");
					disableCV("company"); hideAddCV("div_company_cv");
					disableCV("position");hideAddCV("div_position_cv");
					if(sel=="")form.company.value=0;
					if(sel=="")form.position.value=0;
				} else if(id=="region") {
					hideAddCV("div_city_cv");
					if(sel=="")form.city.value=0;
					disableCV("company"); hideAddCV("div_company_cv");
					disableCV("position");hideAddCV("div_position_cv");
					if(sel=="")form.company.value=0;
					if(sel=="")form.position.value=0;
				} else if(id=="city") {
					hideAddCV("div_company_cv");
					disableCV("position");hideAddCV("div_position_cv");
					if(sel=="")form.company.value=0;
					if(sel=="")form.position.value=0;
				}else if(id=="company"){
					hideAddCV("div_position_cv");
					if(sel=="")form.position.value=0;
				} else return true;
		}
		
			
		function showAddCV(id)
		{
			if(d.getElementById(id).style.display=="none")
				d.getElementById(id).style.display="block";			
		}
		function hideAddCV(id)
		{
			if(d.getElementById(id).style.display=="block")
				d.getElementById(id).style.display="none";
		}
		function SetYearListCV(val, sel)
		{
			var objSel = form.till;
			objSel.options.length = 0;			
			objSel.options[0] = new Option("'.JText::_('-- select from list --').'", true, true);
			var tmp = 1;
			if(val == 0) val = '.(date("Y")-70).';
			for(var i='.date("Y").'; i>=val; i-- )
			{
				if(sel && sel==i)
					objSel.options[tmp] = new Option(i, i, true, true);
				else
					objSel.options[tmp] = new Option(i, i);
				tmp++;
			}
		}
		function RecordExistErrorCV(id, val)
		{
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'cvForm').';
			var t=0;
			val = val.toLowerCase();
			for(var i=0; i<form.elements[id].options.length; i++ )
			{
			var opt = form.elements[id].options[i].value.toLowerCase();
				if(opt == val)
				t++;
			}
			if(t>0){
				idUp = id.toUpperCase();
				valUp= val.toUpperCase();
				alert(idUp+" \""+valUp+"\"'. JText::_("is already exists").'");
			} else {
				addCVOption(id, val, val);		
			}
		}
		
		function enableCV(id)
		{
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'cvForm').';
			form.elements[id].disabled = false;			
		}
		
		function disableCV(id)
		{
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'cvForm').';
			form.elements[id].disabled = true;
		}
		
		function validateFormCV()
		{
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'cvForm').';
				if( form.country.value<=0 ) {
	             alert( "'.JText::_("You need to select").' "+"\''.JText::_("Country").'\'" );
	            } else if ( form.region.value<=0 ) {
	              alert( "'.JText::_("You need to select").' "+"\''. JText::_("Region").'\'" );
	            } else if ( form.city.value<=0  ) {
	              alert( "'.JText::_("You need to select").' "+"\''. JText::_("City").'\'" );
	            } else if ( form.company.value<=0  ) {
	              alert( "'.JText::_("You need to select").' "+"\''. JText::_("Company").'\'" );
	            } else if ( form.position.value<=0  ) {
	              alert( "'.JText::_("You need to select").' "+"\''. JText::_("Position").'\'" );
	            } else if ( form.begin.value<=0  ) {
	              alert( "'.JText::_("You need to select").' "+"\''. JText::_("Begin").'\'" );
	            } else {
	              form.submit();
				} 
		}		
		</script>';
		return $script;
	}

	function GenListCore($field, $parent_val, $selected, $disabled = false, $formTo)
	{
		$db = &JFactory::getDBO();
		switch($field)
		{
			case 'country':
				$sql = "SELECT * FROM #__community_plg_edu_country ORDER BY name";
				$db->setQuery($sql);
				$result = $db->loadObjectList();
				$next = 'region';
				break;
			case 'region':
				$sql = "SELECT * FROM #__community_plg_edu_region WHERE country_id='$parent_val' ORDER BY name";
				$db->setQuery($sql);
				$result = $db->loadObjectList();
				$next = 'city';
				break;
			case 'city':
				$sql = "SELECT * FROM #__community_plg_edu_city WHERE region_id='$parent_val' ORDER BY name";
				$db->setQuery($sql);
				$result = $db->loadObjectList();
				$next = 'company';
				break;
			case 'company':
				$sql = "SELECT DISTINCT(company) as name FROM #__community_plg_cv WHERE city_id='$parent_val' GROUP BY company";
				$db->setQuery($sql);
				$result = $db->loadObjectList();
				$next = 'position';
				break;
			case 'position':
				$sql = "SELECT DISTINCT(position) as name FROM #__community_plg_cv WHERE company='".$parent_val."' GROUP BY position";
				$db->setQuery($sql);
				$result = $db->loadObjectList();
				$next = '';
				break;
		}
		$opt = array();$out = array();
		$opt[] = JHTML::_('select.option', 0, JText::_("-- select from list --"));
		if(count($result)>0)
		{
			foreach ($result as $val)
			$opt[] = JHTML::_('select.option', (isset($val->id) ? $val->id : $val->name), ucwords(str_replace('`', '"',$val->name)));
		}
		if($formTo!='search')
		$opt[] = JHTML::_('select.option', -1, JText::_("Other"));

		$out[] = JHTML::_("select.genericlist", $opt, $field, "class='inputbox' style='width: 100%;'
		onChange='itemSelectedCoreCV(this.value, \"".$field."\", \"".$next."\", \"".ucwords(str_replace('`', '"',$selected))."\", \"".$formTo."\")'
		".($disabled ? " disabled" : ""), 'value', 'text', $selected);
		return implode($out);
	}

	function GenListYear($field, $selected = '')
	{
		$opt = array();
		$opt[] = JHTML::_('select.option', 0, JText::_("-- select from list --"));
		for ($i=date("Y"); $i>=date("Y")-70; $i--)
		{
			$opt[] = JHTML::_('select.option', $i, $i);
		}
		$onchange = ($field == 'begin') ? 'onChange=\'SetYearListCV(this.value, "'.$selected.'");\'' : '';
		$out[] = JHTML::_("select.genericlist", $opt, $field, "class='inputbox' ".$onchange, 'value', 'text', $selected);
		return implode($out);
	}

	function GenListMonth($field, $selected = '')
	{
		$month = array(JText::_("january"),JText::_("febrary"),JText::_("march"),JText::_("april"),
		JText::_("may"),JText::_("june"),JText::_("july"),JText::_("august"),JText::_("september"),
		JText::_("october"),JText::_("november"),JText::_("december"));

		$opt = array();
		$opt[] = JHTML::_('select.option', 0, JText::_("-- select from list --"));
		for ($i=0; $i<12; $i++)
		{
			$opt[] = JHTML::_('select.option', $i+1, $month[$i]);
		}
		$out[] = JHTML::_("select.genericlist", $opt, $field, "class='inputbox' ", 'value', 'text', $selected);
		return implode($out);
	}

	function getUserCVData()
	{
		$db     = &JFactory::getDBO();
		$user 	= JFactory::getUser();

		$month = array(JText::_("january"),JText::_("febrary"),JText::_("march"),JText::_("april"),
		JText::_("may"),JText::_("june"),JText::_("july"),JText::_("august"),JText::_("september"),
		JText::_("october"),JText::_("november"),JText::_("december"));

		$itemId 			= $this->params->get('item_itemid');

		$id = (JRequest::getVar('user_id')) ? JRequest::getVar('user_id') : $user->get('id');
		$out_text = '';
		$sql = "SELECT
				cv.*, UCASE(cv.company) as ucompany, UCASE(cv.position) as uposition,
				REPLACE(cnt.name, LEFT(cnt.name, 1), UCASE(LEFT(cnt.name, 1))) AS country, 
				REPLACE(r.name, LEFT(r.name, 1), UCASE(LEFT(r.name, 1))) AS region, 
				REPLACE(ct.name, LEFT(ct.name, 1), UCASE(LEFT(ct.name, 1))) AS city 
				FROM #__community_plg_cv cv 
				JOIN #__community_plg_edu_country cnt ON cv.country_id=cnt.id
				JOIN #__community_plg_edu_region r ON cv.region_id=r.id
				JOIN #__community_plg_edu_city ct ON cv.city_id=ct.id
				WHERE cv.user_id='".$id."'
				ORDER BY cv.begin";
		$db->setQuery($sql);
		$result = $db->loadObjectList();
		if($result)
		{
			foreach($result as $val)
			{

				$bmonth = ($val->bmonth > 0) ? $month[$val->bmonth-1]: 0;
				$tmonth = ($val->tmonth > 0) ? $month[$val->tmonth-1]: 0;
				$remove_link = '';

				if($user->get('id')>0 && ($user->get('id')==$val->user_id || $user->get('gid')==25))
				{
					$this->uri->setVar( 'cv_remove', $val->id );
					$remove_link = '<a class="removeLink"
						onClick=\' if(confirm("'.JText::_('Remove item?').'")) document.location.replace("'.JRoute::_( $this->uri->toString() ).'");\'><img 
						src="'.JURI::root().'plugins/community/cv_images/remove.png" alt="'.JText::_('Remove').'"></a>';
					$this->uri->delVar('cv_remove');
				}

				$byCompany= array('country' => $val->country_id, 'region'=>$val->region_id, 'city'=>$val->city_id,
					'company'=>$val->company);
				$numByCompany = $this->GetUserData($db, $byCompany, 'num');
				$numByCompanyLink = 'index.php?option=com_community&view=customlist&client=user_cv&search=advanced';
				foreach($byCompany as $var => $value)
				{
					$numByCompanyLink .= '&'.$var.'='.urlencode($value);
				}

				$byPosition= array_merge($byCompany, array("position" => $val->position));
				$numByPosition = $this->GetUserData($db, $byPosition, 'num');

				$numByPositionLink = 'index.php?option=com_community&view=customlist&client=user_cv&search=advanced';
				foreach($byPosition as $var=>$value)
				{
					$numByPositionLink .= '&'.$var.'='.urlencode($value);
				}

				$byBegin= array_merge($byCompany, array("begin" => $val->begin, "bmonth"=>$val->bmonth));
				$numByBegin = $this->GetUserData($db, $byBegin, 'num');

				$numByBeginLink = 'index.php?option=com_community&view=customlist&client=user_cv&search=advanced';
				$numByBeginLink .= $numByCompanyLink.'&begin='.$val->begin."&bmonth=".$val->bmonth;


				$this->uri->delVar('Itemid');
				$out_text .= '
				<table width="100%" border="0" cellspacing="0" cellpadding="0" class="userCv">
					<tr valign="top">
						<td width="150px">
								<b>'.JText::_("Company").':</b>
						</td>
						<td width="80%">
							<b>'.str_replace('`', '"', $val->ucompany).'</b>
							&nbsp;(<a href="'.$numByCompanyLink.'">'.$numByCompany.'</a>)
						</td>
						<td rowspan="4">'.$remove_link.'</td>
					</tr>
					<tr>
						<td><b>'.JText::_("Position").':</b></td>
						<td>'.$val->uposition.'
						&nbsp;(<a href="'.$numByPositionLink.'">'.$numByPosition.'</a>)</td>
					</tr>
					<tr>
						<td><b>'.JText::_("Location").':</b></td>
						<td>'.$val->country.', '.$val->region.', '.$val->city.'</td>
					</tr>
					<tr>
						<td><b>'.JText::_("Period").':</b></td>
						<td>'.JText::_("From").' '.(($val->bmonth > 0) ? $bmonth.", " : '') .$val->begin
				.' '.JText::_("till").' '.( ($val->till == '0') ? JText::_("Nowadays") : ( (($val->tmonth > 0) ? $tmonth.", " : '') . $val->till )).'</td>
					</tr>
					'.
				(($val->additional != '') ?
					'<tr>
						<td><b>'.JText::_("Additional").':</b></td>
						<td>'.$val->additional.'</td>
					</tr>
					' : "")
				.'
					<tr>
						<td>
							<a href="'.$numByBeginLink.'">'.JText::_("Find co-workers").'</a> ('.$numByBegin.')
						</td>
						<td></td>
					</tr>
					';
				$out_text .= '
				<tr><td colspan="3" height="5px"></td></tr>
				</table><br>';			
			}
		}
		return $out_text;
	}

	function removeRecord( &$db , $id, $user_id)
	{
		global $mainframe;
		$this->uri          = &JFactory::getURI();
		$this->uri->delVar('cv_remove');

		$db->setQuery("SELECT user_id FROM #__community_plg_cv WHERE id = '$id'");
		$owner_id = $db->loadResult();
		$db->setQuery("SELECT gid FROM #__users WHERE id = '$user_id'");
		$userGroup = $db->loadResult();
		if($user_id==$owner_id || $userGroup==25)
		{
			$db->setQuery( 'DELETE FROM #__community_plg_cv WHERE id = '.$id );
			$db->query();
		}
		$mainframe->redirect($this->uri->toString(), JText::_('Work experience is removed'), 'Error');
	}

	function AddRecord( &$db, $user_id )
	{
		global $mainframe;
		$this->uri = &JFactory::getURI();
		$this->uri->delVar('task');
		$itemId	= $this->params->get('item_itemid');
		$this->uri->setVar('Itemid', $itemId);
		$core =$_POST;
		$core['user_id'] = $user_id;
		if($this->GetUserData($db, $core, ''))
		$mainframe->redirect($this->uri->toString(), JText::_('Record already exists'));
		$core['company'] = str_replace('"', "`",$core['company']);
		$core['company'] = str_replace("'", "`",$core['company']);
		$sql = "INSERT INTO #__community_plg_cv
		VALUES ('','$user_id', '".$core['country']."', '".$core['region']."','".$core['city']."',
			'".$core['begin']."', '".$core['bmonth']."','".$core['till']."','".$core['tmonth']."',
			'".$core['company']."',
			NOW(), LCASE('".$core['position']."'), '".$core['additional']."')";				
		$db->setQuery( $sql);
		//echo $db->_sql;
		$db->query();
		$mainframe->redirect($this->uri->toString(), JText::_('Record is added'));
	}

	function onCustomUserList($client, $limitstart, $limit)
	{
		if ($client != 'user_cv') { return; }
		global $mainframe;
		$db = &JFactory::getDBO();
		$this->uri          = &JFactory::getURI();
		//=========================
		$itemId 			= $this->params->get('item_itemid');
		JRequest::setVar('customlist_tmpl', $this->params->get('template', 'default'));
		
		$sel = $_GET;
		
		$out_form = '
			<style>		
			.cv_table {border: 1px solid #ddd;}
			.hidden {display: none;}
			</style>';
		$out_form .= $this->GenJScript();

		$out_form .= '
		<a href="javascript:void(0);" onClick="cv_showCvForm()" name="write">Advanced search</a>
			<div id="cv" style="display: none; visibility: hidden;">
			';
		$out_form .= '
			<form action="'.$this->uri->toString().'" method="GET" name="cvForm">
			<table width="100%" class="cv_table" cellpadding="2">';
		$out_form .= '
			<input type="hidden" name="option" value="com_community">
			<input type="hidden" name="view" value="customlist">
			<input type="hidden" name="client" value="user_cv">
			<input type="hidden" name="search" value="advanced">';
		if(!isset($sel['begin']))
		$sel['begin'] = 0;
		if(!isset($sel['till']))
		$sel['till'] = 0;
		if(!isset($sel['bmonth']))
		$sel['bmonth'] = 0;
		if(!isset($sel['tmonth']))
		$sel['tmonth'] = 0;
		if(!isset($sel['position']))
		$sel['position'] = 0;
		$out_form .= $this->GenForm( 'search', $sel );

		$out_form .= '
			<tr>
				<td></td>
				<td>
					<input type="submit" value="'.JText::_("Search").'" class="button"">
				</td>
			</tr>
		</table><br><br>
		</form>
		</div><br>';

		$out_form .= '
			<script language="JavaScript">';
		if($sel['country']>0){
			$out_form .= 'd.getElementById("country").value = "'.$sel['country'].'";';
			$out_form .= 'itemSelectedCoreCV("'.$sel['country'].'", "country", "region", "'.$sel['region'].'", "search");';
		}
		if(isset($sel['region']))
		$out_form .= 'itemSelectedCoreCV("'.$sel['region'].'", "region", "city", "'.(isset($sel['city']) ? $sel['city'] :'').'", "search");';
		if(isset($sel['city']))
		$out_form .= 'itemSelectedCoreCV("'.$sel['city'].'", "city", "company", "'.$sel['company'].'", "search");';
		if(isset($sel['company']))
		$out_form .= 'itemSelectedCoreCV("'.$sel['company'].'", "company", "position", "'.$sel['position'].'", "search");';
		if(isset($sel['position']))
		$out_form .= 'itemSelectedCoreCV("'.$sel['position'].'", "position", "", "", "search");';
		if(isset($sel['begin']))
		$out_form .= 'SetYearListCV("'.$sel['begin'].'", "'.$sel['till'].'");';
		$out_form .= '
		</script>';				

		$users = $this->GetUserData($db, $sel, '', $limitstart, $limit);
		$total = $this->GetUserData($db, $sel, 'num');
		$out_form .= "<br><b>".JText::_('Number of found users').": ".$total."</b><br>";

		if(count($users)>0)
		{
			$month = array(JText::_("january"),JText::_("febrary"),JText::_("march"),JText::_("april"),
			JText::_("may"),JText::_("june"),JText::_("july"),JText::_("august"),JText::_("september"),
			JText::_("october"),JText::_("november"),JText::_("december"));


			$this->uri->setVar( 'Itemid', $itemId );
				
			for($i = 0; $i < count($users); $i++)
			{
				$bmonth = ($users[$i]->bmonth > 0) ? $month[$users[$i]->bmonth-1]: 0;
				$tmonth = ($users[$i]->tmonth > 0) ? $month[$users[$i]->tmonth-1]: 0;
				$users[$i]->id = $users[$i]->user_id;
				$users[$i]->custom_data = '
				<table width="100%" border="0" cellspacing="0" cellpadding="0" class="userCv">
					<tr valign="top">
						<td width="150px">
								<b>'.JText::_("Company").':</b>
						</td>
						<td width="80%"><b>'.str_replace('`', '"',$users[$i]->ucompany).'</b></td>
					</tr>
					<tr>
						<td><b>'.JText::_("Position").':</b></td>
						<td>'.$users[$i]->uposition.'</td>
					</tr>
					<tr>
						<td><b>'.JText::_("Period").':</b></td>
						<td>'.JText::_("From").' '.(($users[$i]->bmonth > 0) ? $bmonth.", " : '') .$users[$i]->begin
				.' '.JText::_("till").' '.( ($users[$i]->till == '0') ? JText::_("Nowadays") : ( (($users[$i]->tmonth > 0) ? $tmonth.", " : '') . $users[$i]->till )).'</td>
					</tr>
				</table>';
			}
		}

		$return = new StdClass();

		$return->page_title = JText::_("User Work Experience");
		$return->total = $total;
		$return->description = &$out_form;
		$return->users = &$users;

		//=========================
		return $return;
	}

	function GetUserData(&$db, $var = array(), $return, $limitstart = false, $limit = false)
	{
		$sql = "SELECT u.id, u.username, cv.*, UCASE(cv.company) as ucompany, UCASE(cv.position) as uposition
			FROM #__community_plg_cv cv
			JOIN #__users u ON cv.user_id=u.id
			";
		$where = array();
		if( $var['country'] > 0) $where[]= " cv.country_id='".$var['country']."'" ;
		if( isset($sel['region']) && $var['region'] > 0 ) $where[]= " cv.region_id='".$var['region']."'";
		if( isset($sel['city']) && $var['city'] > 0 ) $where[]= " cv.city_id='".$var['city']."'";
		if( isset($var['company']) && $var['company']!='0')
		$where[]= " cv.company='".$var['company']."'";
		if( isset($var['position']) && $var['position']!='0')
		$where[]= " cv.position='".$var['position']."'";
		if( isset($var['begin']) && $var['begin'] > 0 )
		$where[]= " cv.begin>='".$var['begin']."'";
		if( isset($var['bmonth']) && $var['bmonth'] > 0 )
		$where[]= " cv.bmonth BETWEEN '".$var['bmonth']."' AND '12'";
		if( isset($var['till']) && $var['till'] > 0 )
		$where[] = " cv.till BETWEEN '1' AND '".$var['till']."'";
		if( isset($var['tmonth']) && $var['tmonth'] > 0 )
		$where[] = " cv.tmonth<='".$var['tmonth']."'";
		if( isset($var['user_id']) &&  $var['user_id'] > 0)
		$where[] = " cv.user_id = '".$var['user_id']."'";
		if( count($where) > 0 )
		{
			$sql .= " WHERE ". implode(" AND ", $where);
		}
		$sql .= " GROUP BY cv.id ORDER BY cv.ctime";
		if($limit)
		$sql .= " LIMIT $limitstart, $limit";
		$db->setQuery( $sql);
		$users = $db->loadObjectList();
		if($return=='num')
		return count($users);
		return $users;
	}
}
