<?php
/**
 * @Copyright 2006-2009 JoomSuite
 * @created 05.03.2009
 */
defined('_JEXEC') or die('Restricted Access');

jimport('joomla.plugin.plugin');

/**
 * People Touch User Plugin
 *
 * @package		PeopleTouch
 * @since 		1.5
 */
class plgUserCommunity extends JPlugin {

	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @param object $subject The object to observe
	 * @param 	array  $config  An array that holds the plugin configuration
	 * @since 1.5
	 */
	function plgUserCommunity(& $subject, $config)
	{
		parent::__construct($subject, $config);
	}



	/**
	 * People Touch delete user method
	 *
	 * Method is called after user data is deleted from the database
	 *
	 * @param 	array		holds the user data
	 * @param	boolean		true if user was succesfully stored in the database
	 * @param	string		message
	 */
	function onAfterDeleteUser($user, $succes, $msg)
	{
		if(!$succes) {
			return false;
		}
		global $mainframe;
		$db = &JFactory::getDBO();
		$uid = $db->Quote($user['id']);
		$sql = "DELETE FROM #__community_user_mapping WHERE `user_id` = ".$uid;
		$db->setQuery($sql);
		$db->query();
		$sql = "DELETE FROM #__community_userrelations WHERE `user_id` = {$uid} OR `friend_id` = {$uid} ";
		$db->setQuery($sql);
		$db->query();
		$sql = "DELETE FROM #__community_blocks WHERE `user_id` = {$uid}";
		$db->setQuery($sql);
		$db->query();
		$sql = "DELETE FROM #__community_guests WHERE `user_id` = {$uid} OR `guest_id` = {$uid}";
		$db->setQuery($sql);
		$db->query();
		$sql = "DELETE FROM #__community_user_extra WHERE `user_id` = {$uid}";
		$db->setQuery($sql);
		$db->query();



		return true;
		// only the $user['id'] exists and carries valid information

		// Call a function in the external app to delete the user
		// ThirdPartyApp::deleteUser($user['id']);
	}

}
?>