<?php
defined('_JEXEC') or die('Restricted access');

class plgCommunityGuestBook extends JPlugin
{
	function plgCommunityGuestBook(&$subject, $config)
	{
		parent::__construct($subject, $config);
	}

	function onProfileExtra( $book_owner, $params=null, $name )
	{
		if ($name != 'guestbook'){return;}
		//init and prepare some vars
		$db                 = &JFactory::getDBO();
		$doc                = &JFactory::getDocument();
		$this->dispacher    = &JDispatcher::getInstance();
		$editor             = JFactory::getEditor($this->params->get( 'editor', 'tinymce' ));
		$this->uri          = &JFactory::getURI();
		$session            = &JFactory::getSession();
		$this->current_user = JFactory::getUser();
		$this->config       = JFactory::getConfig();
		$this->uri->setVar('Itemid', (int)$this->params->get('item_itemid', JRequest::getInt('Itemid')));


		$moder_groups  = $this->params->get( 'moder_groups' );
		$submit_groups = $this->params->get( 'submit_groups' );
		$view_groups   = $this->params->get( 'view_groups' );

		if( !is_array( $moder_groups ) ){
		    $moder_groups = array( $moder_groups );
		}
		
		if( !is_array( $submit_groups ) ){
		    $submit_groups = array( $submit_groups );
		}
		
		if( !is_array( $view_groups ) ){
		    $view_groups = array( $view_groups );
		}

		if ($this->current_user->gid < 1 && !in_array( 29, $view_groups ))
			return;
		elseif ($this->current_user->gid > 0 && !in_array( $this->current_user->gid, $view_groups ))
			return;

		if( JRequest::getVar('gb_text', 0, 'POST') ) {
		    $this->_sendMessage($book_owner);
		}

		$this->can_remove = false;

		$can_submit = false;

		if (in_array( $this->current_user->gid, $submit_groups ) && $this->current_user->gid > 0)
		    $can_submit = true;
	    elseif (in_array( 29, $submit_groups ) && $this->current_user->gid < 1)
		    $can_submit = true;

		JHTML::_( 'behavior.mootools' );

		$out_text = '';

		//if user can submit messages look in request for vars of new messages and save them
		if( $can_submit ) {

			//render the mesage form

			if( !$this->current_user->id ) {
				$doc->addScriptDeclaration(
        	             "function gb_sendRecord()
        	             {
        	               var form = document.gb_from;
        	               if( !form.gb_author.value ) {
        	                 alert( '".JText::_("You need to type your name")."' );
        	               } else if ( !form.gb_author_email.value ) {
        	                 alert( '".JText::_("You need to type your email")."' );
        	               } else if ( !form.gb_author_email.value.match(/^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/)  ) {
        	                 alert( '".JText::_("Email is wrong. Please try again")."' );
        	               } else {
        	                 form.submit();
        	               }
        	             }
        	             ");

				$name_field  = JText::_( "Your Name" ).': <input type="text" name="gb_author" size="70%">';
				$email_field = JText::_( "Your Email" ).': <input type="text" name="gb_author_email" size="70%">';
			} else {
				$name_field = '';
				$email_field = '';
			}


			if(JRequest::getVar('user_id')!=$this->current_user->id and JRequest::getVar('user_id'))
			$out_text .= '
			<div style="text-align:right">'.
    	                 '<img src="'.JURI::root().'plugins/community/gb_images/add.png" alt="'.JText::_('Add new').'" align="absmiddle">'.
  	                  '<a href="javascript:void(0);" onClick="gb_showFormMsg()" name="write">'.
			JText::_( 'Write new message' ).
  	                  '</a>'.
  	                '</div><br>';

			if (JRequest::getVar('layout')!='edit')
			{
				$uri = $this->uri->toString();
				$out_text .='
				<div id="gb_form_container" style="display: none; visibility: hidden;">'.
						'<form action="'.$this->uri->toString().'" method="post" name="gb_from">'.
						'<table width="100%">'.
				( $name_field ? '<tr>'.
          	  			'<td colspan="2">'.$name_field.'</td>'.
          				'</tr>' : '' ).
				( $email_field ? '<tr>'.
        	    		'<td colspan="2">'.$email_field.'</td>'.
        	  			'</tr><tr>' : '' ).
        	    		'<td>'.$editor->display("gb_text", "", '100%', '150', '60', '20', false, array( 'theme' => 'simple' ) ).'</td>'.
        	  			'</tr>
        	  			<tr>'.
        	    		'	<td colspan="2" align="right">
        	    				<input class="button" name="gb_send" value="'.JText::_( 'Send' ).'"
        	    				'.(!$this->current_user->id ? ' type="button" onClick="gb_sendRecord();"' : ' type="submit"').'
        	    					>
        	    			</td>'.
      	    			'</tr>'.
    	    			'</table>'.
    	  				'</form>'.
    					'</div><br>';
			}
			$doc->addScriptDeclaration( "
				var formMsg = null;
				window.addEvent('domready', function(){
					formMsg = $('gb_form_container');
				});
				
				function gb_showFormMsg()
				{	
					if (formMsg.getParent().hasClass('jpane-slider content')){
						formMsg.getParent().setStyle('height', '100%');
					}
					if(formMsg.getStyle('display') == 'none')
					{
						formMsg.setStyles({
							display:'block',
							visibility:'visible'
						});
					}
					else
					{
						formMsg.setStyles({
							display:'none',
							visibility:'hidden'
						});
					}
				}
				");
		}
		
		$doc->addScriptDeclaration("
			function removeMsg(id)
    			{
    				$('gb_container').setHTML(\"<p align='center'><img src='".JURI::root()."/components/com_community/images/loading.gif' border='0' ></p>\");
    				var page = $('gb_page').getValue();
    				xajax_jsCommunityCallPlugin('community', 'guestbook', 'xajax_gbRemoveMessage', [ id, page, '".$book_owner->id."' ]);
    			}
    			
    			function setPage(page)
    			{
    				$('gb_container').setHTML(\"<p align='center'><img src='".JURI::root()."/components/com_community/images/loading.gif' border='0' ></p>\");
    				xajax_jsCommunityCallPlugin('community', 'guestbook', 'xajax_gbChangePage', [ page, '".$book_owner->id."' ]);
    			}
			");

		//render messages
		$records = $this->getRecords($book_owner->id, $this->params->get('limit', 5), 0);

		$total_records = $this->getRecords($book_owner->id, $this->params->get('limit', 5), 0, true);

		$out_text .= '<div id="gb_container">';
		$out_text .= $this->fillMessagesTemplate( $this->params->get( 'messages_template' ), $records );
		$out_text .= '</div>';
		if (JRequest::getVar('task')=='reply' && !JRequest::getVar('gb_text'))
		$doc->addScriptDeclaration("
			window.addEvent('domready',function(){
				gb_showFormMsg();
			});
			");

		// guestbook xajax pagination
		$out_text .= '
			<input type="hidden" name="gb_page" id="gb_page" value="1">
			<input type="hidden" name="gb_old" id="gb_old" value="1">';
		$pages = ceil ($total_records / $this->params->get('limit', 5));
		if($pages > 1)
		{
			$out_text .= '
			<div id="gb_pagination" align="center">
			<p>'.JText::sprintf('JPAGE_CURRENT_OF_TOTAL', 1, $pages).'</p>';
			$out_text .= '&laquo;&nbsp;&nbsp;'.JText::_('Start'). '&nbsp;&nbsp;&nbsp;&nbsp;'. JText::_('Prev').'&nbsp;&nbsp;';
			for ($i = 1; $i <= $pages; $i ++)
			{
				$out_text .= '&nbsp;&nbsp;<a href="javascript: void(0);" id="page'.$i.'" onclick="setPage(\''.$i.'\')">'.($i != 1 ? '<b>'.$i.'</b>' : $i) .'</a>&nbsp;&nbsp;';
			}
			$out_text .= '&nbsp;&nbsp;<a href="javascript: void(0);" onclick="setPage(2)"><b>'.JText::_('Next').'</b></a>&nbsp;&nbsp;';
			$out_text .= '&nbsp;&nbsp;<a href="javascript: void(0);" id="page'.$i.'" onclick="setPage(\''.$pages.'\')"><b>'.JText::_('End').'</b></a>&nbsp;&nbsp;&raquo;';
			$out_text .= '
			</div>';
		}

		$ret = new JSCommunityTab();
		$ret->name  = 'jspt_guestbook';
		$ret->title = JText::_("Guest Book");
		$ret->text  = $out_text;
		return $ret;
	}

	function _sendMessage( $book_owner )
	{
	    global $mainframe;
	    
	    $text = JRequest::getString( 'gb_text', '', 'default', 2 );
		if( !$text ) return;
		$db = &JFactory::getDBO();

		if( $this->current_user->id ){
			$author_field = "author";
			$author_value = $this->current_user->id;
			$author_email_value = $db->getEscaped($this->current_user->email);
		} else {
			$author_field = "not_reg_author";
			$author_value = JRequest::getString( 'gb_author', '' );
			$author_email_value = JRequest::getString( 'gb_author_email', '' );
		}

		$db->setQuery( 'INSERT INTO #__community_plg_guestbook'.
	                 '( '.$author_field.','.( $author_email_value ? ' author_email,' : '' ).' book_owner, text, ctime)'.
	                 'VALUES'.'("'.$db->getEscaped( $author_value ).'",'.( $author_email_value ? ' "'.$author_email_value.'",' : '' ).' "'.$book_owner->id.'", "'.$db->getEscaped($text).'", NOW() )' );
		$db->query();

		/*
		 * insert activity
		 */

		// get username
		$db->setQuery("SELECT id, username, name FROM #__users WHERE id = {$book_owner->id} AND block = 0 LIMIT 1");
		$result = $db->loadObject();
        $this->uri->delVar('task');
		if( $result )
		{
			$activity_text = JText::_('left comment to guestbook of').' '.'<a href="index.php?option=com_community&controller=profile&user_id='.$book_owner->id.'">'.$result->username.'</a>';
			$activity_icon = "plugins/community/icons/comments.png";
			$db->setQuery("INSERT INTO #__community_activity (icon, text, client, client_id, ctime, user_id) VALUES ('{$activity_icon}', '".$db->getEscaped($activity_text)."', 'user', '$author_value', NOW(), '$author_value' )");
			$db->query();
		    if ( $this->current_user->id && ($this->current_user->id != $book_owner->id) ) {
				$this->sendNotification( $this->current_user, $this->current_user->email, $text, $book_owner, $db );
			}else{
			    $this->sendNotification( $author_value, $author_email_value, $text, $book_owner, $db );
			}
			$mainframe->redirect( $this->uri->toString(), JText::_('Your massage was send successfully!'));
		}else{
			$mainframe->redirect( $this->uri->toString(), JText::_('Your massage wasn\'t send !'), 'error');
		}
	}

	function fillMessagesTemplate( $full_template, $messages, $always_show_remove_url = false )
	{
		@include_once('components/com_community/api.php');
		$message_tmpl = preg_replace( "/^.*\[cycle\](.*)\[\/cycle\].*$/s", "\\1", $full_template );

		$cycles_dump = '';
		if( !$messages || !count( $messages ) ) $cycles_dump = JText::_( "There is no messages yet" );

		$k = 0;
		$submit_groups = $this->params->get( 'submit_groups' );
		foreach ( $messages as $message ) {
			$k = 1 - $k;
			$remove_link = '';
			$reply_link = '';
			
			if( $message->author  ){
				$author = JFactory::getUser( $message->author );
				$author_name = JSCommunityApi::getUserSlideMenu($author->id, $author->name);
				if(($this->current_user->id && $message->author != $this->current_user->id) || (!$this->current_user->id && $message->author != $this->current_user->id && in_array(29, $submit_groups))/*|| !JRequest::getVar('user_id')*/)
				$reply_link = '<a href="'.JRoute::_( JURI::root()."index.php?option=com_community&controller=profile&task=reply&user_id=".$author->id."&Itemid=".$this->params->get('item_itemid', JRequest::getInt('Itemid'))).'#write">
					<img src="'.JURI::root().'plugins/community/gb_images/reply.png" width="17px" title="'.JText::_('Reply in user\'s profile page').'" align="absmiddle">'.JText::_('Reply in user\'s profile page').'</a>';
			} else {
				$author = new stdClass();
				$author->id     = 0;
				$author->username = '';
				$author_name = $message->not_reg_author;
			}


			$avatar = "<img src='index2.php?option=com_community&controller=profile&task=avatar&user_id={$author->id}&width=".$this->params->get('avatar_width')."&height=".$this->params->get('avatar_height')."&no_ajax=1'>";

			if( $always_show_remove_url || $this->can_remove || ($this->params->get( 'msg_author_can_remove')==1 && $message->author==$this->current_user->id && $this->current_user->id!=0)) {
				$remove_link = '<a href="javascript: void(0);" onClick="removeMsg('.$message->id.')">
				<img src="'.JURI::root().'plugins/community/gb_images/remove.png" alt="'.JText::_('Remove').'" align="absmiddle"> '.JText::_('Remove Message').'</a>&nbsp;&nbsp;&nbsp;&nbsp;';				
			}
			jimport('joomla.utilities.date');
			$date = new JDate($message->ctime);

			$cycles_dump .= str_replace( array( '[id]', '[avatar]', '[name]', '[remove]', '[reply]', '[text]', '[row]', '[date]' ),
			array( 'gb_msg_'.$message->id, $avatar, $author_name, $remove_link, $reply_link, $message->text, ($k + 1), $date->toFormat($this->params->get('date_format', '%B %a %Y')) ), $message_tmpl );
		}

		return  preg_replace( "/^(.*)\[cycle\](.*)\[\/cycle\](.*)$/s", "\\1".$cycles_dump."\\3", $full_template );
	}

	function sendNotification( $author, $author_email, $text, $book_owner, $db )
	{
		$mail = &JFactory::getMailer();

		if( $this->current_user->id ){
			$author_link  = "<a href='".JRoute::_( JURI::root()."index.php?option=com_community&controller=profile&user_id=".$author->id."&Itemid=".$this->uri->getVar('Itemid') )."'>".$this->current_user->name."</a>";
		} else {
			$author_link  = '<b>'.$author.'</b>';
		}

		$owner_link = "<a href='".JRoute::_( JURI::root()."index.php?option=com_community&controller=profile&user_id=".$book_owner->id."&Itemid=".$this->uri->getVar('Itemid') )."'>".$book_owner->name."</a>" ;
		$url_link   = "<a href='".JRoute::_( JURI::root()."index.php?option=com_community&controller=profile&user_id=".$book_owner->id."&Itemid=".$this->uri->getVar('Itemid') )."'>".JURI::root()."index.php?option=com_community&controller=profile&user_id=".$book_owner->id."&Itemid=".$this->uri->getVar('Itemid')."</a>" ;

		$notification_text = str_replace( array( '[owner]',   '[author]',   '[url]' ),
		array( $owner_link, $author_link, $url_link ), $this->params->get( 'notification_template' ) );

		if( $this->params->get( 'owner_notification' ) ) {

			$sender[0] = $this->config->getValue('config.mailfrom');
			$sender[1] = $this->config->getValue('config.fromname');

			JUTility::sendMail($sender[0], $sender[1], $book_owner->email, JText::_( "New guest book message" ) ,  $notification_text , 1);
		}

		if( $this->params->get( 'notification_email' ) ) {

			$message = array( new stdClass() );
			$message[0]->id = $db->insertid();

			if( $this->current_user->id ){
				$message[0]->author = $this->current_user->id;
			} else {
				$message[0]->not_reg_author = $author;
			}

			$message[0]->text = $text;

			$notification_text .= '<br><hr><br>'.$this->fillMessagesTemplate( $this->params->get( 'messages_template' ), $message, true );

			$addresses = explode( ',', $this->params->get( 'notification_email' ) );

			foreach( $addresses as $address ) {
				$mail->AddAddress( trim( $address ) );
			}

			$sender[0] = $author_email;
			$sender[1] = $this->current_user->id ? $this->current_user->name : $author;
			JUTility::sendMail($sender[0], $sender[1], $addresses,JMailHelper::cleanSubject( JText::_( "New guest book message" ) ) , JMailHelper::cleanBody( $notification_text ), 1);
		}
	}


	/*
	 * Get guestbook activity
	 */
	function onFriendActions( $users, $limit )
	{
		$show = $this->params->get('friends_action', 1);

		if( !$show )
		{
			return;
		}
		$user 	 = JFactory::getUser();
		$user_id = JRequest::getInt('user_id');

		$section = $this->params->get('section');

		$db = &JFactory::getDBO();
		$Itemid = (int)$this->params->get('item_itemid', JRequest::getInt('Itemid'));
		$result = array();

		$sql =
			 " SELECT g.ctime AS date, u.username, u.id, g.book_owner AS author, u2.username AS title "
			 ."\n FROM #__users AS u"
			 ."\n LEFT JOIN #__community_plg_guestbook AS g ON u.id = g.author"
			 ."\n LEFT JOIN #__users AS u2 ON u2.id = g.book_owner"
			 ."\n WHERE 1 AND g.ctime <> '0000-00-00 00:00:00'";
			 if( count( $users ) > 0 )
			 {
			 	$sql .= "\n AND u.id IN (".implode(',', $users ).") ";
			 }
			 if( $user_id == $user->id )
			 {
			 	$sql .= "\n AND u.id <> {$user->id} ";
			 }
			 $sql .= "\n ORDER BY g.ctime DESC LIMIT ".(int)$limit;
			 $db->setQuery( $sql );

			 $records = $db->loadObjectList();
			 foreach( $records AS $rec )
			 {
			 	if( $rec->date && $rec->author && $rec->title )
			 	{
			 		$element = new stdClass();
			 		$element->date     = $rec->date;
			 		$element->user_id  = $rec->id;
			 		$element->username = $rec->username;
			 		$element->action   = JText::_("left a comment to guestbook of");
			 		$element->url      = JRoute::_("index.php?option=com_community&controller=profile&user_id={$rec->author}&Itemid={$Itemid}");
			 		$element->user_id2 = $rec->author;
			 		$element->urlLable = $rec->title;
			 		$element->icon     = JURI::root()."plugins/community/icons/comments.png";
			 		$result[]          = $element;
			 	}
			 }

			 return $result;
	}

	function onUserSlideMenu($user)
	{
	    $current_user = JFactory::getUser();
	    if( $user->id == $current_user->id ) return;
	    $menu = new stdClass();
		$Itemid = $this->params->get('item_itemid', JRequest::getInt('Itemid'));
		$menu->link = JRoute::_("index.php?option=com_community&controller=profile&task=reply&user_id={$user->id}&Itemid={$Itemid}#write");
		$menu->icon="plugins/community/icons/guestbook.png";
		$menu->alt = JText::_("Write a guestbook message");
		return $menu;
	}

	function getRecords($book_owner, $limit, $limit_start, $get_total = false)
	{
		$db = &JFactory::getDBO();
		$this->current_user = JFactory::getUser();
		
		$sql = "SELECT COUNT(*) FROM #__community_plg_guestbook WHERE book_owner = $book_owner ORDER BY ctime DESC";
		$db->setQuery($sql);
		$all = $db->loadResult();
		if($get_total)
    		return $all;

		if($limit)
		{
			if($limit_start >= $all)
			    $limit_start -= $limit;
			if($limit_start < 0) $limit_start = 0; 
			    $sql = "SELECT * FROM #__community_plg_guestbook WHERE book_owner = $book_owner ORDER BY ctime DESC LIMIT $limit_start, $limit";
		}
		else
		    $sql = "SELECT * FROM #__community_plg_guestbook WHERE book_owner = $book_owner ORDER BY ctime DESC";

		$db->setQuery($sql);
		$records = $db->loadObjectList();

		$moder_groups  = $this->params->get( 'moder_groups' );
		$submit_groups = $this->params->get( 'submit_groups' );
		$view_groups   = $this->params->get( 'view_groups' );

		if( !is_array( $moder_groups ) )
		{$moder_groups = array( $moder_groups );}
		if( !is_array( $submit_groups ) )
		{ $submit_groups = array( $submit_groups );}
		if( !is_array( $view_groups ) )
		{ $view_groups = array( $view_groups );}

		$this->can_remove = false;

		if( !count( $moder_groups ) || 
		        ( 
		            $this->current_user->id != 0 &&
		            ( 
		                in_array( $this->current_user->gid, $moder_groups ) || 
		                ($book_owner == $this->current_user->id && $this->params->get( 'owner_is_moderator' ))  
		            )  
		        ) 
	        ) 
        {
			$this->can_remove = true;
		}
		return $records;
	}

	function xajax_gbRemoveMessage(&$objResponse, $id, $page, $book_owner_id)
	{
		$db = &JFactory::getDBO();
		if( !$id ) return $objResponse;
		$db->setQuery( 'DELETE FROM #__community_plg_guestbook WHERE id = '.$id );
		$db->query();
		$limit = $this->params->get('limit', 5);
		if($limit)
		{
			$limit_start = ($page - 1) * $limit;

			$total_records = $this->getRecords($book_owner_id, $limit, $limit_start, true);
			if($limit_start >= $total_records)
			{
				$limit_start -= $limit;
				$page --;
			}
			$records = $this->getRecords($book_owner_id, $limit, $limit_start);
			$new = $this->fillMessagesTemplate( $this->params->get( 'messages_template' ), $records );
			$objResponse->assign('gb_container', 'innerHTML', $new);

			$pages = ceil ($total_records / $limit);
			$pageNav = '';
			if($pages > 1)
			{
				$pageNav .= '<p>'.JText::sprintf('JPAGE_CURRENT_OF_TOTAL', $page, $pages).'</p>';
				if($page != 1)
				{
					$pageNav .= '&laquo;&nbsp;&nbsp;<a href="javascript: void(0);" onclick="setPage(1)"><b>'.JText::_('Start').'</b></a>&nbsp;&nbsp;';
					$pageNav .= '&nbsp;&nbsp;<a href="javascript: void(0);" onclick="setPage(\''.($page - 1).'\')"><b>'.JText::_('Prev').'</b></a>&nbsp;&nbsp;';
				}
				else
				$pageNav .= '&laquo;&nbsp;&nbsp;'.JText::_('Start'). '&nbsp;&nbsp;&nbsp;&nbsp;'. JText::_('Prev').'&nbsp;&nbsp;';
				for ($i = 1; $i <= $pages; $i ++)
				{
					$pageNav .= '&nbsp;&nbsp;<a href="javascript: void(0);" id="page'.$i.'" onclick="setPage(\''.$i.'\')">'.($i != $page ? '<b>'.$i.'</b>' : $i) .'</a>&nbsp;&nbsp;';
				}
				if( $page < $pages)
				{
					$pageNav .= '&nbsp;&nbsp;<a href="javascript: void(0);" onclick="setPage(\''.($page + 1).'\')"><b>'.JText::_('Next').'</b></a>&nbsp;&nbsp;';
					$pageNav .= '&nbsp;&nbsp;<a href="javascript: void(0);" id="page'.$i.'" onclick="setPage(\''.$pages.'\')"><b>'.JText::_('End').'</b></a>&nbsp;&nbsp;&raquo;';
				}
				else
				$pageNav .= '&nbsp;&nbsp;'.JText::_('Next').'&nbsp;&nbsp;&nbsp;&nbsp;'.JText::_('End').'&nbsp;&nbsp;&raquo;';

			}
			$objResponse->assign("gb_pagination", 'innerHTML', $pageNav);
		}
	}

	function xajax_gbChangePage(&$objResponse, $page, $book_owner_id)
	{
		$db = &JFactory::getDBO();
		$limit = $this->params->get('limit', 5);
		if($limit)
		{
			$limit_start = ($page - 1) * $limit;

			$records = $this->getRecords($book_owner_id, $limit, $limit_start);
			$new = $this->fillMessagesTemplate( $this->params->get( 'messages_template' ), $records );
			$objResponse->assign('gb_container', 'innerHTML', $new);
			$objResponse->assign('gb_page', 'value', $page);

			$total_records = $this->getRecords($book_owner_id, $limit, $limit_start, true);

			$pages = ceil ($total_records / $limit);
				
			$pageNav = '';
			if($pages > 1)
			{
				$pageNav .= '<p>'.JText::sprintf('JPAGE_CURRENT_OF_TOTAL', $page, $pages).'</p>';
				if($page != 1)
				{
					$pageNav .= '&laquo;&nbsp;&nbsp;<a href="javascript: void(0);" onclick="setPage(1)"><b>'.JText::_('Start').'</b></a>&nbsp;&nbsp;';
					$pageNav .= '&nbsp;&nbsp;<a href="javascript: void(0);" onclick="setPage(\''.($page - 1).'\')"><b>'.JText::_('Prev').'</b></a>&nbsp;&nbsp;';
				}
				else
				$pageNav .= '&laquo;&nbsp;&nbsp;'.JText::_('Start'). '&nbsp;&nbsp;&nbsp;&nbsp;'. JText::_('Prev').'&nbsp;&nbsp;';
				for ($i = 1; $i <= $pages; $i ++)
				{
					$pageNav .= '&nbsp;&nbsp;<a href="javascript: void(0);" id="page'.$i.'" onclick="setPage(\''.$i.'\')">'.($i != $page ? '<b>'.$i.'</b>' : $i) .'</a>&nbsp;&nbsp;';
				}
				if( $page < $pages)
				{
					$pageNav .= '&nbsp;&nbsp;<a href="javascript: void(0);" onclick="setPage(\''.($page + 1).'\')"><b>'.JText::_('Next').'</b></a>&nbsp;&nbsp;';
					$pageNav .= '&nbsp;&nbsp;<a href="javascript: void(0);" id="page'.$i.'" onclick="setPage(\''.$pages.'\')"><b>'.JText::_('End').'</b></a>&nbsp;&nbsp;&raquo;';
				}
				else
				$pageNav .= '&nbsp;&nbsp;'.JText::_('Next').'&nbsp;&nbsp;&nbsp;&nbsp;'.JText::_('End').'&nbsp;&nbsp;&raquo;';
			}
			$objResponse->assign("gb_pagination", 'innerHTML', $pageNav);
		}
		return $objResponse;
	}

}
?>