<?php
// no direct access
defined ( '_JEXEC' ) or die ( 'Restricted access' );
class plgCommunityJsinbox extends JPLugin 
{
	function plgCommunityJsinbox(&$subject, $config) {
		parent::__construct ( $subject, $config );
		$loaded = $this->loadLanguage ();
	
	}
	
	function onProfileMenu($profile) {
		$user = JFactory::getUser ();
        //check if the component installed or not by existing its foler into administrator area
        $inbox_admin = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jsinbox';
		if ($user->id != $profile->id && JFolder::exists($inbox_admin)) {
			$itemId = $this->params->get ( 'item_itemid', JRequest::getInt ( 'Itemid' ) );
			$mail_type_ids = $this->params->get ( 'mail_type_ids', 0 );
            is_array($mail_type_ids)? null:$mail_type_ids = array($mail_type_ids);
			foreach ($mail_type_ids as $mail_type_id){
                if ($mail_type_id == 0) {
                    $mail_type_name = "a message";
                } else {
                    $mail_type_name = plgCommunityJsinbox::getMessName ( intval ( $mail_type_id ) );
                }

                $uri = & JFactory::getURI ();
                $url = base64_encode ( $uri->toString () );

                $menu = new stdClass ( );
                $menu->link = JRoute::_ ( "index.php?option=com_jsinbox&task=compose&type_id={$mail_type_id}&Itemid={$itemId}&to={$profile->username}&return={$url}" );
                $menu->icon = "plugins/community/icons/mail.png";

                $menu->alt = $this->params->get ( 'menu_item_title', JText::_ ( "Send {$mail_type_name}" ) );
                $menuItems [] = $menu;
            }
			$ret = new stdClass ( );
			if ($this->params->get ( 'show_menu_title', 1 )) {
				$ret->title = JText::_($this->params->get ( 'menu_title', "JS Inbox Menu" ));
			}
			$ret->menuItems = $menuItems;
			return $ret;
		}
	}
	
	function getMessName($mail_type_id = 0) {
		if ($mail_type_id == 0)
			return;
			
		$mail_type_id = (int)$mail_type_id;
		
		$db = JFactory::getDBO ();
		$sql = "SELECT name FROM #__js_inbox_types WHERE id={$mail_type_id}";
		$db->setQuery ( $sql );
		return $db->loadResult ();
	
	}
	
	function onUserSlideMenu($user) {
		$user2 = JFactory::getUser ();
		//check if the component installed or not by existing its foler into administrator area
        $inbox_admin = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jsinbox';
		if ($user2->id == $user->id || !JFolder::exists($inbox_admin)) {
			return;
		}
		
		if ($this->params->get ( 'show_slide_menu_title', 1 )) {
			$mail_type = $this->params->get ( 'mail_type', 1 );
			$ItemId = $this->params->get ( 'item_itemid', JRequest::getInt ( 'Itemid' ) );
			$mail_type_ids = $this->params->get ( 'mail_type_ids', 0 );
            is_array($mail_type_ids)? null:$mail_type_ids = array($mail_type_ids);
			$uri = & JFactory::getURI ();
			$url = base64_encode ( $uri->toString () );
			foreach($mail_type_ids as $mail_type_id){
                if ($mail_type_id == 0) {
                    $mail_type_name = "a message";
                } else {
                    $mail_type_name = plgCommunityJsinbox::getMessName ( intval ( $mail_type_id ) );
                }

                $menu = new stdClass ( );

                $menu->link = JURI::root () . "index.php?option=com_jsinbox&task=compose&type_id={$mail_type_id}&Itemid={$ItemId}&to={$user->username}&return={$url}";
                $menu->icon = "components/com_community/images/mail.png";
                $menu->alt = $this->params->get ( 'menu_item_title', JText::_ ( "Send" ) . ' ' . $mail_type_name );
                $menus[] = $menu;
            //var_dump($menus);die;
            }
			return $menus;
		}
	}
}