<?php
/**
 * @Copyright 2006-2008 JoomSuite
 * @created 27.11.2008
 */
defined('_JEXEC') or die('Restricted Access');

class plgSystemCommunity extends JPlugin
{
	function plgSystemCommunity(&$subject, $config)
	{
		parent::__construct($subject, $config);

	}

	function onAfterInitialise()
	{
		global $mainframe;
		if($mainframe->isAdmin())
		{
			return;
		}
		$user = &JFactory::getUser();
		jimport('joomla.filesystem.file');
		$file = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'includes'.DS.'helper.php';
		if (!JFile::exists($file))
		{
			return;
		}
		require_once(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'includes'.DS.'helper.php');
		require_once(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php');
		if ($user->get('id') > 0)
		{
			$carma = JSCommunityApi::getUserCarma($user->get("id"));
			$carmaList = JSCommunityApi::getCarmaList();
			foreach($carmaList as $key=>$val)
			{
				if ($val['title'] == $carma->title)
				{
					$user->set('karmaindex', $key);
				}
			}
		}

		if (JRequest::getWord('option') == 'com_resource' && JRequest::getVar('client_id', '') == '' && JRequest::getInt('user_id', 0))
		{
			$allowedSection = $this->params->get('available_sections');
			$categoryId = JRequest::getInt('category_id', 0);
			$user_id  = JRequest::getInt('user_id', 0);
			$ini = "";
			if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_community'.DS.'config.ini'))
			{
				$ini = JFile::read(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_community'.DS.'config.ini');
			}
			$compParams = new JParameter($ini);

			if ($categoryId && $user_id && count($compParams->get('general::usr_choose_site_tmpl', array())))
			{
				$section = $this->getCategorySection($categoryId);
				if(!is_array($allowedSection)) settype($allowedSection, 'array');
				if (in_array($section, $allowedSection) )
				{					
					JSCommunityApi::setUserTemplate(JSCommunityApi::getParam('profile_site_template', $mainframe->getTemplate(), $user_id));
				}
			}
		}
	}
	function getCategorySection($catid)
	{
		if (!$catid) return;
		static $data = array();

		if (!@$data[$catid])
		{
			$db = & JFactory::getDBO();
			$sql = "SELECT section_id FROM #__js_res_category WHERE id = ".(int)$catid;
			$db->setQuery($sql);
			$res = $db->loadResult();

			if ($res > 0)
			$data[$catid] = $res;
			else
			$data[$catid] = $catid;
		}
		return $data[$catid];

	}
}

?>