<?php
defined('_JEXEC') or die('Restricted access');

class plgCommunityUser_Edu extends JPlugin
{
	function plgCommunityUser_Edu(&$subject, $config)
	{
		parent::__construct($subject, $config);
	}

	function GetUserEduParamsSrting()
	{
		$edu =  str_replace(", ", ",", strtolower($this->params->get('edu_type')));
		$edu = str_replace(" ", "_", $edu);
		$edu = str_replace("\n", "/", $edu);
		return $edu;
	}
	function onProfileExtra($user, $params = null, $name)
	{
		//init and prepare some vars
		if($name!='user_edu') return;
			
		$db                 = &JFactory::getDBO();
		$this->uri          = &JFactory::getURI();
		$user 				= JFactory::getUser();
		$itemId 			= $this->params->get('item_itemid');

		$remove_id = JRequest::getInt( 'edu_remove' );
		$user_id =  $user->get('id');
		if( $remove_id ) $this->removeEdu( $db, $remove_id , $user_id);

		$this->uri->delVar('edu_remove');
		if(JRequest::getString( 'task') && JRequest::getString( 'task') == "add")
		$this->AddEdu( $db, $user_id );
		$out_text = '';

		$out_text .= '
		<style>		
		.edu_type {border: 1px solid #ddd;}
		.hidden {display: none;}
		.userEdu { border-bottom: 1px solid #ddd; width: 100%; background-color: #FFFFFF;}
		a.removeLink{cursor: pointer;}
		</style>
		';		
		$out_text .= $this->GenJScript();

		if($user->get('id')>0 && (JRequest::getInt('user_id') && $user->get('id')==JRequest::getInt('user_id') || !JRequest::getInt('user_id')))
		{
			$out_text .= '
			<div style="text-align: right;">
			   <img src="'.JURI::root().'plugins/community/icons/add.png" alt="'.JText::_('Add education').'" align="absmiddle">
			   <a href="javascript:void(0);" onClick="ue_showEduForm()" name="write">'.
			JText::_( 'Add new education' ).'</a>
	  	    </div><br>
			<div id="edu" style="display: none; visibility: hidden;">
			&nbsp;* '.JText::_("All fields are required").'<br><br>';
			$this->uri->setVar( 'task', 'add' );
			$out_text .= '
			<form action="'.$this->uri->toString().'" method="post" name=eduForm>
			<table width="100%" class="edu_type" cellpadding="2">';
			$this->uri->delVar('task');

			$out_text .= $this->GenForm('add');

			$out_text .= '
				<tr>
					<td></td>
					<td>
						<input type="button" value="'.JText::_("Save").'" class="button"
						onClick="validateForm();">
					</td>
				</tr>
			</table><br><br>
			</form>
			</div>';
		}
		$out_text .= $this->getUserEdu();

		$ret = new JSCommunityTab();
		$ret->name  = 'jspt_user_edu';
		$ret->title = JText::_("User Education");
		$ret->text  = $out_text;
		return $ret;
	}

	function GenForm( $formTo, $sel = false )
	{
		$out = array();
		$fields[] = "country";
		$list["country"] = $this->GenListCore("country", 0, '', 0, $formTo);
		$fields[]= "region";
		$list[ "region"] = $this->GenListCore("region", 0, '', 1, $formTo);
		$fields[]= "city";
		$list["city"]= $this->GenListCore("city", 0, '', 1, $formTo);
		/*if($this->params->get("edu_type"))
		 {*/
		$fields[] = "type";
		$list["type"] = $this->GenListCore("type", 0, (isset($sel['type'])?$sel['type']:''), 1, $formTo);
		$fields[] = "name";
		$list["name"] = $this->GenListCore("name", 0, '', 1, $formTo);
		//}
		$fields[]= "first";
		$list["first"] =  $this->GenListYear("first", (isset($sel['first'])?$sel['first']:0));
		$fields[]= "begin";
		$list["begin"] = $this->GenListYear("begin",(isset($sel['begin'])?$sel['begin']:0));
		$fields[]= "till";
		$list["till"] = $this->GenListYear("till",(isset($sel['till'])?$sel['till']:0));

		for($i=0; $i<3; $i++)
		{
			$parent_val = ($i==0)? ', false, false, ""' : ', document.eduForm.elements["'.$fields[$i-1].'"].value, false, ""';
			$out[] = '
			<tr>
				<td width="100px">'.JText::_(ucfirst($fields[$i])).'</td>
				<td width=90% id="'.$fields[$i].'List">'.$list[$fields[$i]].'</td>
			</tr>
			<tr>
				<td></td>
				<td width="90%">
				<div id="div_'.$fields[$i].'" style="display: none;">
					<input type="text" id="Add_'.$fields[$i].'" class="inputbox" size="50">&nbsp;
					<input type="button" class="button" value="'.JText::_("Add").'" 
					onClick=\'if(this.form.Add_'.$fields[$i].'.value!="") xajax_AddSelectItem("'.$fields[$i].'", this.form.Add_'.$fields[$i].'.value, "'.$fields[$i+1].'" '.$parent_val.');\'>
				</div>
				</td>
			</tr>';
		}
		/*if($this->params->get("edu_type"))
		 {*/
		$edu =  $this->GetUserEduParamsSrting();
		$parent_val = ', document.eduForm.elements["'.$fields[3].'"].value, false, ""';
		$out[] = '
			<tr>
				<td width="100px">'.JText::_(ucfirst($fields[3])).'</td>
				<td width=90% id="'.$fields[3].'List">'.$list[$fields[3]].'</td>
			</tr>
			<tr>
				<td width="100px">'.JText::_(ucfirst($fields[4])).'</td>
				<td width=90% id="'.$fields[4].'List">'.$list[$fields[4]].'</td>
			</tr>
			<tr>
				<td></td>
				<td width="90%">
				<div id="div_'.$fields[4].'" style="display: none;">
					<input type="text" id="Add_'.$fields[4].'" class="inputbox" size="50">&nbsp;
					<input type="button" class="button" value="'.JText::_("Add").'" 
					onClick=\'xajax_AddSelectItem("'.$fields[4].'", this.form.Add_'.$fields[4].'.value,  "'.$edu.'" '.$parent_val.');\'>
				</div>
				</td>
			</tr>
			<tr><td colspan="2" id="add_types" width="100%"></td></tr>';			
		$tmp = 5;
		/*}
		 else $tmp = 3;*/
		for($i=$tmp; $i<count($fields); $i++)
		{
			$out[] = '<tr><td>'.JText::_(ucfirst($fields[$i])).'</td>
			<td id="'.$fields[$i].'List">'.$list[$fields[$i]].'</td></tr>';
		}
		return implode($out);
	}

	function GenJScript()
	{
		$script ='
		<script type="text/javascript">	
			var d = document;
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'eduForm').';
		function addOption(selectId, txt, val)
		{
			if(txt!="")
			{
				var form = document.forms.eduForm;
			    var objSel = form.elements[selectId];
				objSel.options[objSel.options.length-1] = new Option(txt, val, true, true);
				objSel.options[objSel.options.length] = new Option("'.JText::_('Other').'", -1);
				form.elements["Add_"+selectId].value="";
				hideAdd("div_"+selectId);
			}
		}
		
		function ue_showEduForm()
		{
			var eduForm = document.getElementById("edu");
			var show 	= eduForm.style.display=="none";

			// show the form to calc height
			eduForm.style.display = "block";
			
			
			// Search for slider div
			var slider = eduForm.parentNode;
			
			for (var i = 0; i < 10 && slider; i++)
			{
				if (slider.className && slider.className.match(/jpane-slider/))
				{
					var formHeight 		= eduForm.offsetHeight;
					var sliderHeight	= slider.offsetHeight;
					
					if (show)
						slider.style.height = (sliderHeight + formHeight) + "px";
					else
						slider.style.height = (sliderHeight - formHeight) + "px";
					
					break;
				}
				
				slider = slider.parentNode;
			}
			
			/// Show / Hide form
			eduForm.style.display 		= show ? "block" : "none";
			eduForm.style.visibility 	= show ? "visible" : "hidden";
		}
		
		function itemSelectedCore(val, id, next, sel, formTo)
		{
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'eduForm').';
		//alert("val="+val+";id="+id+"; next="+next+"; sel="+sel)		
				if(val<0) {
					form.elements["Add_"+id].value="";					
					showAdd("div_" + id);form.elements["Add_" + id].focus( );
					if(next!="") disable(next);
				} else if (val==0) {				
					if(id!="type") hideAdd("div_" + id);
					if(next!="") disable(next);					
				} else {				
					if(next!="") {
					form.elements[next].options[0].text = "'. JText::_("Loading").'...";
					if(next!="name") xajax_GetSelectListCore(next, val, sel, formTo);
					else {
							xajax_GetSchoolNames(val, form.elements["city"].value, sel, formTo);
					}
					enable(next);
					}
					if(id!="type") hideAdd("div_" + id);
				}
				if(id=="country") {
					disable("region"); hideAdd("div_region");
					disable("city"); hideAdd("div_city");disable("type"); 
					disable("name");hideAdd("div_name");
					if(sel=="")form.elements["type"].value=0;
					if(sel=="")form.elements["name"].value=0;
					d.getElementById("add_types").innerHTML = "";
				} else if(id=="region") {
					disable("city");hideAdd("div_city");disable("type");
					disable("name");hideAdd("div_name");
					if(sel=="")form.elements["type"].value=0;
					if(sel=="")form.elements["name"].value=0;
					d.getElementById("add_types").innerHTML = "";
				} else if(id=="city") {
					disable("type");disable("name");hideAdd("div_name");
					if(sel=="")form.elements["type"].value=0;
					if(sel=="")form.elements["name"].value=0;
					d.getElementById("add_types").innerHTML = "";
				}else if(id=="type"){
					disable("name");hideAdd("div_name");
					if(sel=="")form.elements["name"].value=0;
					d.getElementById("add_types").innerHTML = "";
				} else
					d.getElementById("add_types").innerHTML = "";
		}
		
		function ShowAddTypes(val, sel, city, type, formTo)
		{
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'eduForm').';
			if(val<0) {
				showAdd("div_name");form.elements["Add_name"].focus( );
				hideAdd("add_types");
				d.getElementById("add_types").innerHTML = "";
			}else if(val==0) {
				hideAdd("div_name");
				hideAdd("add_types");
				d.getElementById("add_types").innerHTML = "";
			} else {
				showAdd("add_types");
				hideAdd("div_name");
				city = (city) ? city : form.elements["city"].value;
				type = (type) ? type : form.elements["type"].value;
				xajax_GetAddTypes(val, type, city, sel, formTo);
			}
		} 
				
		function itemSelectedAdd(current, val, id, next, sel, formTo)
		{
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'eduForm').';
			if(val<0){
				form.elements["Add_"+current].value="";					
				showAdd("div_" + current);form.elements["Add_" + current].focus( );		
				if(id){ disable(id); hideAdd("div_" + id);}
			} else if (val==0) {
			 	hideAdd("div_" + current);
				if(id) {disable(id); hideAdd("div_" + id);}
			} else {
				if(id){
					form.elements[id].options[0].text = "'. JText::_("Loading").'...";
					if(next!="")
						xajax_GetSelectListAdd(form.elements["type"].value, next, id, val, document.eduForm.elements["city"].value, sel, formTo);
					enable(id);
					hideAdd("div_" + current);
					hideAdd("div_" + id);
					}		
			}
		}
		
		function SetYearList(first, begin, till)
		{
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'eduForm').';
			var objSel = form.begin;
			var objSelT = form.till;
			objSel.options.length = 0;		
			objSelT.options.length = 0;		
			objSel.options[0] = new Option("'.JText::_('-- select from list --').'", true, true);
			objSelT.options[0] = new Option("'.JText::_('-- select from list --').'", true, true);
			var tmp = 1;
			if(first == 0) first = '.(date("Y")-70).';
			for(var i='.date("Y").'; i>=first; i-- )
			{
				if(begin && begin==i)
					objSel.options[tmp] = new Option(i, i, true, true);
				else
					objSel.options[tmp] = new Option(i, i);
				tmp++;
			}
			var tmp = 1;
			for(var i='.date("Y").'+10; i>=first; i-- )
			{
				if(till && till==i)
					objSelT.options[tmp] = new Option(i, i, true, true);
				else
					objSelT.options[tmp] = new Option(i, i);
				tmp++;
			}
		}
		
		function showAdd(id)
		{
			if(d.getElementById(id).style.display=="none")
				d.getElementById(id).style.display="block";			
		}
		function hideAdd(id)
		{
			if(d.getElementById(id).style.display=="block")
				d.getElementById(id).style.display="none";
		}
		
		function RecordExistError(id, val)
		{
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'eduForm').';
		var t=0;
		val = val.toLowerCase();
			for(var i=0; i<form.elements[id].options.length; i++ )
			{
			var opt = form.elements[id].options[i].value.toLowerCase();
				if(opt == val)
				t++;
			}
			if(t>0){
				id = id.toUpperCase();
				val= val.toUpperCase();
				alert(id+" \""+val+"\" is already exists");
			} else{
				addOption(id, val, val);
				itemSelectedAdd(id, val, "");		
			}
		}
		
		function enable(id)
		{
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'eduForm').';
			form.elements[id].disabled = false;			
		}
		
		function disable(id)
		{
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'eduForm').';
			form.elements[id].disabled = true;
		}
		
		function validateForm()
		{
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'eduForm').';
				if( form.country.value<=0 ) {
	             alert( "'.JText::_("You need to select").' "+"\''.JText::_("Country").'\'" );
	            } else if ( form.region.value<=0 ) {
	              alert( "'.JText::_("You need to select").' "+"\''. JText::_("Region").'\'" );
	            } else if ( form.city.value<=0  ) {
	              alert( "'.JText::_("You need to select").' "+"\''. JText::_("City").'\'" );
	            } else if ( form.type.value<=0  ) {
	              alert( "'.JText::_("You need to select").' "+"\''. JText::_("Type").'\'" );
	            } else if ( form.name.value<=0  ) {
	              alert( "'.JText::_("You need to select").' "+"\''. JText::_("Name").'\'" );
	            } else if ( form.first.value<=0  ) {
	              alert( "'.JText::_("You need to select").' "+"\''. JText::_("First").'\'" );
	            } else if ( form.begin.value<=0  ) {
	              alert( "'.JText::_("You need to select").' "+"\''. JText::_("Begin").'\'" );
	            } else if ( form.till.value<=0  ) {
	              alert( "'.JText::_("You need to select").' "+"\''. JText::_("Till").'\'" );
	            } else {
	            	if ( form.first.value>form.begin.value  ) {
		              alert( "\''.JText::_("Begin").'\' "+"'.JText::_("couldn't be less than").' "+"\''.JText::_("First").'\'");
		            } else if ( form.first.value>form.till.value  ) {
		              alert( "\''.JText::_("Till").'\' "+"'.JText::_("couldn't be less than").' "+"\''.JText::_("First").'\'");
		            } else if ( form.begin.value>form.till.value  ) {
		              alert( "\''.JText::_("Till").'\' "+"'.JText::_("couldn't be less than").' "+"\''.JText::_("Begin").'\'");
		            } else{
		             form.submit();
					}
	          	} 
		}		
		</script>';
		return $script;
	}

	function GenListCore($field, $parent_val, $selected, $disabled = false, $formTo, $edu=false )
	{
		$db = &JFactory::getDBO();
		$result = array();
		$next = '';
		switch($field)
		{
			case 'country':
				$sql = "SELECT * FROM #__community_plg_edu_country  ORDER BY name";
				$db->setQuery($sql);
				$result = $db->loadObjectList();
				$next = 'region';
				break;
			case 'region':
				$sql = "SELECT * FROM #__community_plg_edu_region WHERE country_id='$parent_val' ORDER BY name";
				$db->setQuery($sql);
				$result = $db->loadObjectList();
				$next = 'city';
				break;
			case 'city':
				$sql = "SELECT * FROM #__community_plg_edu_city WHERE region_id='$parent_val' ORDER BY name";
				$db->setQuery($sql);
				$result = $db->loadObjectList();
				$next = 'type';
				break;
			case 'type':
				$next = 'name';
				if($edu)
				{
					$edu_type = explode("/", $edu);
					foreach($edu_type as $k=>$val)
					{
						$types = explode("::", $val);
						$result[$k]->id = $types[0];
						$result[$k]->name = ucfirst(str_replace("_", " ", $types[0]));
					}
				}
				break;
		}
		$opt = array();$out = array();
		$opt[] = JHTML::_('select.option', 0, JText::_("-- select from list --"));
		if(count($result)>0)
		{
			foreach ($result as $val)
			$opt[] = JHTML::_('select.option', $val->id, ucfirst($val->name));
		}
		if($formTo!='search' && $field!='type')
		$opt[] = JHTML::_('select.option', -1, JText::_("Other"));

		$out[] = JHTML::_("select.genericlist", $opt, $field, "class='inputbox' style='width: 100%;'
		onChange='itemSelectedCore(this.value, \"".$field."\", \"".$next."\", \"".$selected."\", \"".$formTo."\")'
		".($disabled ? " disabled" : ""), 'value', 'text', $selected);
		return implode($out);
	}

	function GenListSchool($edu, $parent_val, $city, $selected = '', $formTo)
	{
		$db = &JFactory::getDBO();
		$edu_type = explode("/", strtolower($edu[0]));
		$field = 'name';
		foreach($edu_type as $types)
		{
			$type = explode("::",$types);
			if($type[0]==$parent_val)
			$fields = explode(",", $type[1]);
		}
		$sql = "SELECT Distinct(school), id FROM #__community_plg_edu WHERE
		city_id='$city' and type='$parent_val'
		GROUP BY school ORDER BY school";
		$db->setQuery($sql);
		$result = $db->loadObjectList();
		$opt[] = JHTML::_('select.option', 0, JText::_("-- select from list --"));
		if(count($result)>0)
		{
			foreach ($result as $val)
			{
				$opt[] = JHTML::_('select.option', $val->school, ucfirst(str_replace("_", " ", $val->school)) );
			}
		}
		if($formTo!='search')
		$opt[] = JHTML::_('select.option', -1, JText::_("Other"));
		$out[] = JHTML::_("select.genericlist", $opt, $field, "class='inputbox' style='width: 100%;'
		onChange='ShowAddTypes(this.value, \"".$selected."\", \"".$city."\", \"\", \"".$formTo."\" );' ", 'value',
		 'text', $selected );
		return implode($out);
	}

	function GenAddTypes($fields, $parent_val, $school, $city, $selected = '', $formTo)
	{
		$list = '<table border="0" width="100%" cellpadding="2" cellspacing="0">';
		foreach($fields as $k => $field)
		{
			$field = trim($field);
			$list .= '<tr>
				<td width="100px">'.JText::_(ucfirst(str_replace("_", " ",$field))).'</td>
				<td width=90% id="'.$field.'List">';		
			$result = array();
			$opt = array();
			$out = array();
			$next = '';
			$disabled = true;
			$opt[] = JHTML::_('select.option', 0, JText::_("-- select from list --"));

			if($formTo!='search')
			$opt[] = JHTML::_('select.option', -1, JText::_("Other"));
			$out[] = JHTML::_("select.genericlist", $opt, $field, "class='inputbox' style='width: 100%;'
			onChange='itemSelectedAdd(this.value, \"".$field."\", \"".( isset($fields[$k+1]) ? $fields[$k+1] : '')."\", \"".$selected."\", ".$formTo." )' ".($disabled ? "disabled":""), 'value',
			'text', $selected );
			$list .= implode($out);
			$list .= '</td>
			</tr>
			<tr>
				<td></td>
				<td width="90%">
				<div id="div_'.$field.'" style="display: none;">
					<span id="error_'.$field.'" class="error"></span>
					<input type="text" id="Add_'.$field.'" class="inputbox" size="50">&nbsp;
					<input type="button" class="button" value="'.JText::_("Add").'" 
					onClick=\'xajax_AddSelectItem("'.$field.'", this.form.Add_'.$field.'.value, 
					"'.implode (",",$fields).'", this.form.city.value, 
					'. (($k==0) ? "this.form.name.value" : "this.form.".$fields[$k-1].".value") .', "" ); \'>
				</div>
				</td>
			</tr>';		
		}
		$list .= '</table>';
		return $list;
	}

	function GenListAdd($type, $next, $id, $parent_val, $city, $selected = '', $formTo)
	{
		$db = &JFactory::getDBO();
		$fields = explode(",", $next);
		$opt = array();
		$out = array();
		$opt[] = JHTML::_('select.option', 0, JText::_("-- select from list --"));
		$tmp=array();
		$k = array_search($id, $fields);
		$enable = isset($fields[$k+1]) ? $fields[$k+1] : '';
		$sql = "SELECT DISTINCT(ex.value)
		FROM #__community_plg_edu_extra ex
		JOIN #__community_plg_edu ed
		ON ex.edu_id = ed.id
		WHERE ed.type = '$type' AND ex.type = '$id'
		AND ex.parent = '$parent_val'
		GROUP BY ex.value ORDER BY ex.value ";
		$db->setQuery($sql);
		$result = $db->loadObjectList();
		$option = '';
		if(count($result)>0) {
			foreach ($result as $val) {
				if(!in_array($val->value, $tmp)) {
					$tmp[] = $val->value;
					if($val->value!='0')
					$opt[] =  JHTML::_('select.option', ucfirst(str_replace("_"," ",$val->value)), ucfirst(str_replace("_"," ",$val->value)));
				}
			}
		}
		if($formTo!='search')
		$opt[] = JHTML::_('select.option', -1, JText::_("Other"));
		$out[] = JHTML::_("select.genericlist", $opt, $id, "class='inputbox' style='width: 100%;'
		onChange='itemSelectedAdd(\"".$id."\", this.value, \"".$enable."\", \"".$next."\", \"".$selected."\", \"".$formTo."\" )'", 'value',
		 'text', ucfirst($selected));	
		return implode($out);
	}

	function GenListYear($field, $selected = '', $first = false)
	{
		$opt = array();
		$opt[] = JHTML::_('select.option', 0, JText::_("-- select from list --"));
		$year = ($field=='till') ? date("Y")+10 : date("Y");
		for ($i=$year; $i>=date("Y")-70; $i--)
		{
			$opt[] = JHTML::_('select.option', $i, $i);
		}
		$event = ($field=='first') ? "onChange='SetYearList(this.value);'" : "";
		$out[] = JHTML::_("select.genericlist", $opt, $field, "class='inputbox' ".$event, 'value', 'text', $selected);
		return implode($out);
	}

	function getUserEdu()
	{
		$db     = &JFactory::getDBO();
		$user 	= JFactory::getUser();
		jimport('joomla.utilities.date');

		$itemId 			= $this->params->get('item_itemid');

		$id = (JRequest::getVar('user_id')) ? JRequest::getVar('user_id') : $user->get('id');
		$out_text = '';
		$sql = "SELECT ed.*, UCASE(ed.school) as uschool,
				REPLACE(cnt.name, LEFT(cnt.name, 1), UCASE(LEFT(cnt.name, 1))) AS country, 
				REPLACE(r.name, LEFT(r.name, 1), UCASE(LEFT(r.name, 1))) AS region, 
				REPLACE(ct.name, LEFT(ct.name, 1), UCASE(LEFT(ct.name, 1))) AS city 
				FROM #__community_plg_edu ed 
				JOIN #__community_plg_edu_country cnt ON ed.country_id=cnt.id
				JOIN #__community_plg_edu_region r ON ed.region_id=r.id
				JOIN #__community_plg_edu_city ct ON ed.city_id=ct.id
				WHERE ed.user_id='".$id."'
				ORDER BY ed.from";
		$db->setQuery($sql);

		$result = $db->loadObjectList();
		foreach($result as $val)
		{
			$remove_link = '';
			if($user->get('id')>0 && ($user->get('id')==$val->user_id || $user->get('gid')==25))
			{
				$this->uri->setVar( 'edu_remove', $val->id );
				$remove_link = '<a class="removeLink"
					onClick=\' if(confirm("'.JText::_('Remove item?').'")) document.location.replace("'.JRoute::_( $this->uri->toString() ).'");\'><img 
					src="'.JURI::root().'plugins/community/icons/remove.png" alt="'.JText::_('Remove').'"></a>';
				$this->uri->delVar('edu_remove');
			}

			$this->uri->delVar('Itemid');

			$bySchool= array('country'=>$val->country_id, 'region'=>$val->region_id, 'city'=>$val->city_id,
				'type'=>$val->type, 'name'=>$val->school);
			$numBySchool = $this->GetUserData($db, $bySchool, 'num');
			$numBySchoolLink = 'index.php?option=com_community&view=customlist&client=user_edu&search=advanced';
			foreach($bySchool as $var=>$value)
			{
				$numBySchoolLink .= '&'.$var.'='.$value;
			}

			$byFirst = $bySchool + array('first'=>$val->first);

			$numByFirst = count($this->GetUserData($db, $byFirst, ''));
			$numByFirstLink = $numBySchoolLink.'&first='.$val->first.'&Itemid='.$itemId;

			$numBySchoolLink .='&first=0&Itemid='.$itemId;
			$byAdd = $bySchool;

			$types = $this->GetTypesValues($db, $val->id);
			$add = array();

			$numByAddLink = '';
			foreach($types as $value)
			{
				$numByAdd = 0;
				if($value->value!='0')
				{
					$numByAddLink .= 'index.php?option=com_community&view=customlist&client=user_edu&search=advanced';

					$byAdd = $byAdd + array($value->type => $value->value);

					foreach($byAdd as $var=>$valAdd)
					{
						$numByAddLink .= '&'.$var.'='.$valAdd;
					}
					$numByAdd = $this->GetUserData($db, $byAdd, 'num');

					$add[] = strtolower(str_replace("_", " ", $value->type)).': '
					.$value->uvalue.
					($numByAdd > 0 ? '&nbsp;(<a href="'.$numByAddLink.'&first=0&Itemid='.$itemId.'">'.$numByAdd.'</a>)':'');
				}
			}
			$out_text .= '
			<table width="100%" border="0" celspacing="0" cellpadding="0" class="userEdu">
				<tr valign="top">
					<td width="150px">
							<b>'.strtoupper(str_replace("_", " ", $val->type)).':</b>
					</td>
					<td width="80%">
						<b>'.$val->uschool.'</b>'.
			($numBySchool > 0 ? '&nbsp;(<a href="'.$numBySchoolLink.'">'.$numBySchool.'</a>)':'').'<br>
						<span class="small">'.implode("; ", $add).'</span>
					</td>
					<td rowspan="4">'.$remove_link.'</td>
				</tr>
				<tr>
					<td><b>'.JText::_("Location").':</b></td>
					<td>'.ucfirst($val->country).', '.ucfirst($val->region).', '.ucfirst($val->city).'</td>
				</tr>
				<tr>
					<td><b>'.JText::_("Period").':</b></td>
					<td>'.$val->from.'-'.$val->till.'</td>
				</tr>
				<tr>
					<td>
						<a href="'.$numByFirstLink.'">'.JText::_("Find classmates").'</a> ('.$numByFirst.')
					</td>
					<td></td>
				</tr>
				';
			$out_text .= '
			<tr><td colspan="3" height="5px"></td></tr>
			</table><br>';			
		}
		return $out_text;
	}

	function removeEdu( &$db , $id, $user_id)
	{
		$db->setQuery("SELECT user_id FROM #__community_plg_edu WHERE id = '$id'");
		$owner_id = $db->loadResult();
		$db->setQuery("SELECT gid FROM #__users WHERE id = '$user_id'");
		$userGroup = $db->loadResult();
		if($user_id==$owner_id || $userGroup==25)
		{
			$db->setQuery( 'DELETE FROM #__community_plg_edu WHERE id = '.$id );
			$db->query();
			$db->setQuery( 'DELETE FROM #__community_plg_edu_extra WHERE edu_id = '.$id );
			$db->query();
		}
		return JError::raiseWarning(100, JText::_('Education is removed'));
	}

	function AddEdu( &$db, $user_id )
	{
		global $mainframe;
		$this->uri = &JFactory::getURI();
		$this->uri->delVar('task');
		$itemId	= $this->params->get('item_itemid');
		$this->uri->setVar('Itemid', $itemId);
		$core =$_POST;
		$core['user_id'] = $user_id;
		if (isset($core['view'])) unset($core['view']);
		
		if($this->GetUserData($db, $core, ''))
		$mainframe->redirect($this->uri->toString(), JText::_('Record already exists'));
		
		$tmp = array_keys($core);
		$name = array_search('name', $tmp);
		$first = array_search('first',$tmp);
		$tmpsel = $core;
		if($name && $first)
		$add = (($first-$name)==1) ? array() : array_splice($tmpsel, $name+1, $first-$name-1);
		$core['name'] = str_replace("#", "", $core['name']);
		$sql = "INSERT INTO #__community_plg_edu
		VALUES ('','$user_id', '".$core['country']."', '".$core['region']."','".$core['city']."',
			'".$core['first']."','".$core['begin']."','".$core['till']."','".$core['type']."',
			NOW(), LCASE('".$core['name']."'))";				
		$db->setQuery( $sql);
		$db->query();
		$edu_id = $db->insertid();
		$tmp = 0;
		foreach($add as $type=>$val)
		{
			$values[$tmp] = $val;
			$parent = ($tmp==0) ? $core['name'] : $values[$tmp-1];
			if($val==-1)
			$val = 0;
			$sql = "INSERT INTO #__community_plg_edu_extra VALUES('', '$edu_id', LCASE('".$parent."'), LCASE('".$type."'), LCASE('".$val."'))";
			$db->setQuery( $sql);
			$db->query();
			$tmp++;
		}
		$mainframe->redirect($this->uri->toString(), JText::_('Education is added'));
	}

	function onCustomUserList($client, $limitstart, $limit)
	{
		if ($client != 'user_edu') { return; }
		global $mainframe;
		$db = &JFactory::getDBO();
		$this->uri          = &JFactory::getURI();
		//=========================
		$edu = $this->GetUserEduParamsSrting();
		JRequest::setVar('customlist_tmpl', $this->params->get('template', 'default'));
		$itemId 			= $this->params->get('item_itemid');

		$sel = $_GET;

		$tmp = array();
		$add = array();
		$tmpsel = $sel;
		foreach($sel as $k=>$val)
		$tmp[] = $k;
		$name = array_search('name', $tmp);
		$first = array_search('first',$tmp);
		if($name && $first)
		$add = (($first-$name)==1) ? array() : array_splice($tmpsel, $name+1, $first-$name-1);

		$keys = array_keys($add);
		$values = array_values($add);

		$out_form = '
			<style>		
			.edu_type {border: 1px solid #ddd;}
			.hidden {display: none;}
			</style>';
		$out_form .= $this->GenJScript();

		$out_form .= '
		<a href="javascript:void(0);" onClick="ue_showEduForm()" name="write">Advanced search</a>
			<div id="edu" style="display: none; visibility: hidden;">
			';
		$out_form .= '
			<form action="'.$this->uri->toString().'" method="GET" name="eduForm">
			<table width="100%" class="edu_type" cellpadding="2">';
		$out_form .= '
			<input type="hidden" name="option" value="com_community">
			<input type="hidden" name="view" value="customlist">
			<input type="hidden" name="client" value="user_edu">
			<input type="hidden" name="search" value="advanced">';

		$out_form .= $this->GenForm( 'search', $sel );

		$out_form .= '
			<tr>
				<td></td>
				<td>
					<input type="submit" value="'.JText::_("Search").'" class="button"">
				</td>
			</tr>
		</table><br><br>
		</form>
		</div><br>';
		if(isset($sel['name']) && $sel['name']!='0' && isset($sel['type']) && $sel['type']!="0")
		{
			$out_form .= '
			<table cellpadding="0">
				<tr>';		

			$this->uri->delVar('Itemid');

			if($sel['first'] && $sel['first']>0)
			{
				$out_form .= '
					<td><a href="index.php?option=com_community&view=customlist&client=user_edu&search=first&country='.$sel['country'].'&region='.$sel['region'].'&city='.$sel['city'].'&type='.$sel['type'].'&name='.$sel['name'].'&first='.$sel['first'].'&Itemid='.$itemId.'"  name="write">'.JText::_('Search by').' '.JText::_('classmates').'</a>&nbsp;&nbsp;</td>';
			}

			if(count($add)>0)
			{
				$add1 = $add;
				foreach($add1 as $type=>$val)
				{
					if($val=='0' || $val=='')
					unset($add1[$type]);
				}

				$out_form .= '<td><a href="index.php?option=com_community&view=customlist&client=user_edu&search=type&country='.$sel['country'].'&region='.$sel['region'].'&city='.$sel['city'].'&type='.$sel['type'].'&name='.$sel['name'].'&Itemid='.$itemId.'"  name="write">'.JText::_('Search by').' '.str_replace("_"," ",$sel['type']).'</a>&nbsp;&nbsp;</td>';
					
				$adv = ''; $k = 0;
				foreach($add1 as $type=>$val)
				{
					if($val!='0')
					{
						$adv .=  '&'.$type.'='.$val;
						if($k!=count($add1)-1)
						$out_form .= '<td>
						<a href="index.php?option=com_community&view=customlist&client=user_edu&search=advanced&country='.$sel['country'].'&region='.$sel['region'].'&city='.$sel['city'].'&type='.$sel['type'].'&name='.$sel['name'].$adv.'&first=0&Itemid='.$itemId.'"  name="write">'.JText::_('Search by').' '.str_replace("_"," ",$type).'</a>&nbsp;&nbsp;</td>';
					}
					$k++;
				}
			}
			$out_form .= '
				</tr>
			</table>';
		}
		$keys = array_keys($add);
		$values = array_values($add);
		$out_form .= '
			<script language="JavaScript">';
		if($sel['country']>0){
			$out_form .= 'd.getElementById("country").value = "'.$sel['country'].'";';
			$out_form .= 'itemSelectedCore("'.$sel['country'].'", "country", "region", "'.$sel['region'].'", "search");';
		}
		if(isset($sel['region']))
		$out_form .= 'itemSelectedCore("'.$sel['region'].'", "region", "city", "'.(isset($sel['city'])?$sel['city']:'').'", "search");';
		if(isset($sel['city']))
		$out_form .= 'itemSelectedCore("'.$sel['city'].'", "city", "type", "'.(isset($sel['type'])?$sel['type']:'').'", "search");';
		if(isset($sel['type']))
		$out_form .= '//itemSelectedCore("'.$sel['type'].'", "type", "name", "'.$sel['name'].'", "search");
				xajax_GetSchoolNames("'.$sel['type'].'", "'.$sel['city'].'",  "'.$sel['name'].'",  "search");
				ShowAddTypes("'.$sel['name'].'", "'.($values ? $values[0] : '').'" ,"'.$sel['city'].'", "'.(isset($sel['type'])?$sel['type']:'').'", "search");
			';
		$out_form .= 'SetYearList("'.$sel['first'].'", "'.(isset($sel['begin'])?$sel['begin']:'').'", "'.(isset($sel['till'])?$sel['till']:'').'");';
		$edu_type = explode("/", $edu);
		if(isset($sel['type']))
		{
			foreach($edu_type as $types)
			{
				$type = explode("::",$types);
				if($type[0]==$sel['type'])
				{
					$keys = explode(",", $type[1]);
				}
			}
			foreach($keys as $val)
			{
				if(count($add)==0)
				{
					$add[$val] = '';
					break;
				}
				if (array_key_exists($val, $add) && ($add[$val]=='0' || $add[$val]==''))
				break;
				if(!array_key_exists($val, $add))
				$add[$val] = '';
			}
		}
		if(count($add)>0)
		{
			$k = 0;
			foreach($add as $type=>$val)
			{
				$parent = ($k==0) ? $sel['name'] : $values[$k-1];
				$out_form .= 'xajax_GetSelectListAdd("'.$sel['type'].'", "'.implode(",", $keys).'", "'.$type.'", "'.$parent.'", "'.$sel['city'].'", "'.$val.'", "search");';
				$k++;
			}
		}
		$out_form .= '
		</script>';				

		$users = $this->GetUserData($db, $sel, '', $limitstart, $limit);
		
		$out_form .= "<br><b>".JText::_('Number of found users').": ".count($users)."</b><br>";

		if(count($users)>0)
		{

			$this->uri->setVar( 'Itemid', $itemId );
			$values = array();
			for($i = 0; $i < count($users); $i++)
			{
				if($types = $this->GetTypesValues($db,  $users[$i]->edu_id))
				{
					$tmp = array();
					foreach($types as $value)
					{
						if($value->value != '0')
						$tmp[] = strtolower($value->type).": ".$value->uvalue;
					}
					$users[$i]->value = '<br><span class="small">'.implode("; ", $tmp).'</span>';
				}

				$users[$i]->custom_data = '
				<table width="100%" align="left" border="0" cellpadding="0" cellspacing="0">
				<tr align="left" valign="top">
					<td width="100px"><b>'.ucfirst(str_replace("_"," ",$users[$i]->type)).':</b></td>
					<td><b>'.$users[$i]->uschool.'</b> '
					.$users[$i]->value.'</td>
				</tr>
				<tr align="left">
					<td><b>'.JText::_('First').':</b></td>
					<td>'.$users[$i]->first.'</td>
				</tr>
				<tr align="left">
					<td><b>'.JText::_('Period').':</b></td>
					<td>'.$users[$i]->from.' - '.$users[$i]->till.'</td>
				</tr>
				</table>';
			}
		}
		$return = new StdClass();

		$return->page_title = JText::_("User Education");
		$return->description = &$out_form;
		$return->total = count($users);
		$return->users = &$users;

		//=========================
		return $return;
	}
	function GetTypesValues(&$db, $id)
	{
		$sql = "SELECT type, value, UCASE(value) as uvalue FROM #__community_plg_edu_extra WHERE edu_id='$id' ORDER BY id";
		$db->setQuery( $sql);
		return $db->loadObjectList();
	}

	function GetUserData(&$db, $var = array(), $return, $limitstart = false, $limit = false)
	{
		$tmp = array();
		$add = array();
		$tmpsel = $var;
		foreach($var as $k=>$val)
		$tmp[] = $k;
		$name = array_search('name', $tmp);
		$first = ($return=='num') ? count($var) : array_search('first',$tmp);
		if($name && $first)
		$add = (($first-$name)==1) ? array() : array_splice($tmpsel, $name+1, $first-$name-1);

		$sql = "SELECT u.id, u.username, ed.first, ed.from, ed.till, ed.type,
			ed.school, UCASE(ed.school) as uschool, ed.id edu_id, ex.parent, UCASE(ex.parent) as uparent, ex.value, UCASE(ex.value) as uvalue
			FROM #__community_plg_edu ed
			JOIN #__users u ON ed.user_id=u.id
			JOIN #__community_plg_edu_extra ex ON ed.id=ex.edu_id
			";

		if(isset($var['country']) && $var['country']>0) $where[]= " WHERE  ed.country_id='".$var['country']."'" ;
		if(isset($var['region']) && $var['region']>0)$where[]= " ed.region_id='".$var['region']."'";
		if(isset($var['city']) && $var['city']>0) $where[]= " ed.city_id='".$var['city']."'";
		if(isset($var['type']) && $var['type']!='0') $where[]= " ed.type='".$var['type']."'";
		if(isset($var['name']) && $var['name']!='0')$where[]= " ed.school='".$var['name']."'";
		if(isset($var['first']) && $var['first']>0)$where[]= " ed.first='".$var['first']."'";
		if(isset($var['begin']) && $var['begin']>0)$where[]= " ed.from>='".$var['begin']."'";
		if(isset($var['till']) && $var['till']>0)$where[] = " ed.till<='".$var['till']."'";
		if(isset($var['user_id']) &&  $var['user_id']>0) $where[] = " cv.user_id = '".$var->user_id."'";

		$keys = array_keys($add);
		$values = array_values($add);
		$addtypes = array();
		foreach($add as $type=>$val)
		{
			if($val!="0" && $val!='-1') $addtypes[$type] = $val;
		}
		if (count($addtypes)>0)
		{
			if(count($addtypes) == 1) {
				$parent = $var['name'];
				$k = 0;
			}else {
				$parent = $values[count($addtypes)-2];
				$k = count($addtypes)-1;
			}
			$where[] = " ex.type='".strtolower($keys[$k])."' AND ex.value = LCASE('".$values[$k]."') AND ex.parent = LCASE('".$parent."')";
		}
		if(count($where)>0)
		$sql .= implode(" AND ", $where);
		$sql .= " GROUP BY ed.id ORDER BY ed.ctime";
		if($limit)
		$sql .= " LIMIT $limitstart, $limit";
		$db->setQuery( $sql);
		//echo $db->_sql."<br><br>";
		$users = $db->loadObjectList();
		if($return=='num')
		return count($users);
		return $users;
	}
}

?>