<?php
defined('_JEXEC') or die('Restricted access');

class plgCommunityUser_Places extends JPlugin
{
	function plgCommunityUser_Places(&$subject, $config)
	{
		parent::__construct($subject, $config);
	}

	function onProfileExtra($user, $params = null, $name)
	{
		//init and prepare some vars
		if($name!='user_places') return;
			
		$db                 = &JFactory::getDBO();
		$this->uri          = &JFactory::getURI();
		$user 				= JFactory::getUser();
		$itemId 			= $this->params->get('item_itemid');

		$remove_id = JRequest::getInt( 'plc_remove' );
		$user_id =  $user->get('id');
		if( $remove_id ) $this->removeRecord( $db, $remove_id , $user_id);

		$this->uri->delVar('plc_remove');
		if(JRequest::getString( 'task') && JRequest::getString( 'task') == "add_place")
		$this->AddRecord( $db, $user_id );
		$out_text = '';

		$out_text .= '
		<style>		
		.plc_table {border: 1px solid #ddd;}
		.hidden {display: none;}
		.userPlaces { border-bottom: 1px solid #ddd; width: 100%; background-color: #FFFFFF;}
		a.removeLink{cursor: pointer;}
		</style>
		';		

		if($user->get('id')>0 && (JRequest::getInt('user_id') && $user->get('id')==JRequest::getInt('user_id') || !JRequest::getInt('user_id')))
		{
			$out_text .= '
			<div style="text-align: right;">
			   <img src="'.JURI::root().'plugins/community/plc_images/add.png" alt="'.JText::_('Add new record').'" align="absmiddle">
			   <a href="javascript:void(0);" onClick="plc_showPlcForm()" name="write">'.
			JText::_( 'Add new record' ).'</a>
	  	    </div><br>
	  	    <div id="plc" style="display: none; visibility: hidden;">
			';
				
			$this->uri->setVar( 'task', 'add_place' );
			$out_text .= '
			<form action="'.$this->uri->toString().'" method="post" name="plcForm">
			<table width="100%" class="plc_table" cellpadding="2">';
			$this->uri->delVar('task');
				
			$out_text .= $this->GenForm('add');
			$out_text .= $this->GenJScript();

			$out_text .= '
				<tr>
					<td></td>
					<td>
						<input type="button" value="'.JText::_("Save").'" class="button"
						onClick="validateFormPlace();">
					</td>
				</tr>
			</table><br><br>
			</form>
			</div>';
		}
		$out_text .= $this->getUserPlacesData();

		$ret = new JSCommunityTab();
		$ret->name  = 'jspt_user_places';
		$ret->title = JText::_("User Places");
		$ret->text  = $out_text;
		return $ret;
	}

	function GenForm( $formTo, $sel = false )
	{
		$out = array();
		$fields[] = "country";
		$list["country"] = $this->GenListCore("country", 0, '', 0, $formTo);
		$fields[]= "region";
		$list[ "region"] = $this->GenListCore("region", 0, '', 1, $formTo);
		$fields[]= "city";
		$list["city"]= $this->GenListCore("city", 0, '', 1, $formTo);
		$fields[]= "place";

		$fields[]= "begin";
		$list["begin"] = $this->GenListYear("begin",(isset($sel['begin'])?$sel['begin']:0));
		$fields[]= "till";
		$list["till"] = $this->GenListYear("till",(isset($sel['till'])?$sel['till']:0));

		$fields[]= "additional";

		for($i=0; $i<3; $i++)
		{
			$parent_val = ($i==0)? ', false, false, "Place"' : ', document.plcForm.elements["'.$fields[$i-1].'"].value, false, "Place"';
			$out[] = '
			<tr>
				<td width="120px">'.JText::_(ucfirst($fields[$i])).'</td>
				<td width="85%" id="'.$fields[$i].'ListPlc">'.$list[$fields[$i]].'</td>
			</tr>
			<tr>
				<td></td>
				<td>
				<div id="div_'.$fields[$i].'_plc" style="display: none;">
					<input type="text" id="Add_'.$fields[$i].'" class="inputbox" size="50">&nbsp;
					<input type="button" class="button" value="'.JText::_("Add").'" 
					onClick=\'if(this.form.Add_'.$fields[$i].'.value!="") xajax_AddSelectItem("'.$fields[$i].'", this.form.Add_'.$fields[$i].'.value, "'.$fields[$i+1].'" '.$parent_val.');\'>
				</div>
				</td>
			</tr>';
		}
		$opt = array();
		$opt[] = JHTML::_('select.option', 0,  JText::_("-- select from list --"));
		$opt[] = JHTML::_('select.option', "living", JText::_(ucfirst("living")));
		$opt[] = JHTML::_('select.option', "rest", JText::_(ucfirst("rest")));
		$placeList = JHTML::_("select.genericlist", $opt, "place",
		"class='inputbox' style='width: 100%;' 
		onChange='ShowAddFieldsPlace(this.value, \"".(isset($sel['place'])?$sel['place']:'')."\", \"".$formTo."\");'
		".(!isset($sel['place']) ? "disabled" : ""),
		 'value', 'text', (isset($sel['place'])?$sel['place']:''));

		$livingList = $this->GenListCore('living', '', (isset($sel['living']) ? $sel['living'] : 0), 1, $formTo);
		$restList = $this->GenListCore('rest', '', (isset($sel['rest']) ? $sel['rest'] : 0), 1, $formTo);
		$houseList = $this->GenListCore('house', '', (isset($sel['house']) ? $sel['house'] : 0), 1, $formTo);

		$living = '
		<div id="living_tab_plc" style="display: none;">
			<table width="100%" cellspacing="0" cellpadding="2" border="0">
				<tr>
					<td width="120px">'.JText::_("Street / District").'</td>
					<td width="85%" id="livingListPlc">'.$livingList.'</td>
				</tr>
				<tr>
					<td></td>
					<td>
					<div id="div_living_plc" style="display: none;">
						<input type="text" id="Add_living" class="inputbox" size="50">&nbsp;
						<input type="button" class="button" value="'.JText::_("Add").'" 
						onClick=\'RecordExistErrorPlace("living", this.form.Add_living.value);
						itemSelectedCorePlace(this.form.living.value, "living", "house", "", "add");\'>
					</div>
					</td>
				</tr>
				<tr>
					<td>'.JText::_("House / Num.").'</td>
					<td id="houseListPlc">'.$houseList.'</td>
				</tr>
				<tr>
					<td></td>
					<td>
					<div id="div_house_plc" style="display: none;">
						<input type="text" id="Add_house" class="inputbox" size="50">&nbsp;
						<input type="button" class="button" value="'.JText::_("Add").'" 
						onClick=\'RecordExistErrorPlace("house", this.form.Add_house.value);
						itemSelectedCorePlace(this.form.house.value, "house", "", "", "add");\'>
					</div>
					</td>
				</tr>
			</table>
		</div>
		';
		$rest = '
		<div id="rest_tab_plc" style="display: none;">
			<table width="100%" cellspacing="0" cellpadding="2" border="0">
				<tr>
					<td width="120px">'.JText::_("Name").'</td>
					<td width="85%" id="restListPlc">'.$restList.'</td>
				</tr>
				<tr>
					<td></td>
					<td>
					<div id="div_rest_plc" style="display: none;">
						<input type="text" id="Add_rest" class="inputbox" size="50">&nbsp;
						<input type="button" class="button" value="'.JText::_("Add").'" 
						onClick=\'RecordExistErrorPlace("rest", this.form.Add_rest.value);
						itemSelectedCorePlace(this.form.rest.value, "rest", "", "", "add");\'>
					</div>
					</td>
				</tr>
			</table>
		</div>
		';
		$out[] = '
			<tr>
				<td width="120px">'.JText::_("Place of").'</td>
				<td width="85%" id="placeList">'.$placeList.'</td>
			</tr>
			<tr>
				<td colspan="2">
				'.$living.$rest.'</td>
			</tr>
			'; 

		for($i=4; $i<6; $i++)
		{
			$out[] = '
			<tr>
				<td>'.JText::_(ucfirst($fields[$i])).'</td>
				<td id="'.$fields[$i].'List">
					'.$list[$fields[$i]].'
				</td>
			</tr>';
		}

		if($formTo != 'search')
		$out[] = '
			<tr valign="top">
				<td>'.JText::_(ucfirst($fields[6])).'</td>
				<td>
					<textarea class="inputbox" style="width: 50%" rows="4" name="additional" class="inbox"></textarea>
				</td>
			</tr>';
		return implode($out);
	}

	function GenJScript()
	{
		$script ='
		<script language="JavaScript">	
			var d=document;
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'plcForm').';
		function addPlaceOption(selectId, txt, val)
		{
			if(txt!="")
			{
			    var objSel = form.elements[selectId];
				objSel.options[objSel.options.length-1] = new Option(txt, val, true, true);
				objSel.options[objSel.options.length] = new Option("'.JText::_('Other').'", -1);
				form.elements["Add_"+selectId].value="";
				hideAddPlace("div_"+selectId + "_plc");
			}
		}
		
		function plc_showPlcForm()
		{
			var plcForm = document.getElementById("plc");
			var show 	= plcForm.style.display=="none";

			// show the form to calc height
			plcForm.style.display = "block";
			
			
			// Search for slider div
			var slider = plcForm.parentNode;
			
			for (var i = 0; i < 10 && slider; i++)
			{
				if (slider.className && slider.className.match(/jpane-slider/))
				{
					var formHeight 		= plcForm.offsetHeight;
					var sliderHeight	= slider.offsetHeight;
					
					if (show)
						slider.style.height = (sliderHeight + formHeight) + "px";
					else
						slider.style.height = (sliderHeight - formHeight) + "px";
					
					break;
				}
				
				slider = slider.parentNode;
			}
			
			/// Show / Hide form
			plcForm.style.display 		= show ? "block" : "none";
			plcForm.style.visibility 	= show ? "visible" : "hidden";
		}
		
		function itemSelectedCorePlace(val, id, next, sel, formTo)
		{
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'plcForm').';
				if(val<0) {
					form.elements["Add_" + id].value="";
					showAddPlace("div_" + id + "_plc");
					form.elements["Add_" + id].focus( );
					if(next!="") disablePlace(next);
				} else if (val==0) {				
					hideAddPlace("div_" + id + "_plc");
					if(next!="") disablePlace(next);					
				} else {		
					if(next!="") {
						if(next!="place")
						{						
							form.elements[next].options[0].text = "'. JText::_("Loading").'...";
							if(next=="living" || next=="rest" || next=="house")
								xajax_GetSelectListCorePlaces(next, val+"."+form.elements["city"].value, sel, formTo);
							else
								xajax_GetSelectListCorePlaces(next, val, sel, formTo);	
						}				
						else
							enablePlace(next);
					}
					if(id!="place") hideAddPlace("div_" + id + "_plc");
				}
				if(id=="country") {
					hideAddPlace("div_region_plc");
					if(sel=="")form.region.value=0;
					if(sel=="")form.city.value=0;
					disablePlace("city"); hideAddPlace("div_city_plc");
					disablePlace("place");
					if(formTo=="add"){ form.elements["place"].value = 0; ShowAddFieldsPlace (0);}
				} else if(id=="region") {
					if(sel=="")form.city.value=0;
					hideAddPlace("div_city_plc");
					disablePlace("place");
					if(formTo=="add") { form.elements["place"].value = 0; ShowAddFieldsPlace (0);}
				} else if(id=="city") {
					if(formTo=="add") { form.elements["place"].value = 0; ShowAddFieldsPlace (0);}
				}else if(id=="place"){
					if(formTo=="add") ShowAddFieldsPlace (0);
				} else return true;
		}
		
		function ShowAddFieldsPlace(val, sel, formTo)
		{
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'plcForm').';
			if(val<=0) {
				hideAddPlace("living_tab_plc"); hideAddPlace("rest_tab_plc");
				disablePlace("living");
				disablePlace("house");
				disablePlace("rest");
				form.living.value = 0;
				form.house.value = 0;
				form.rest.value = 0;
			} else {
				if(val=="living")
				{	
					form.rest.value = 0;
					hideAddPlace("rest_tab_plc");	
					form.elements[val].options[0].text = "'. JText::_("Loading").'...";
					itemSelectedCorePlace(val, "place", val, sel, formTo);
					disablePlace("house");
					showAddPlace("living_tab_plc");
				} else {
					form.living.value = 0;
					form.house.value = 0;	
					hideAddPlace("living_tab_plc");
					form.elements[val].options[0].text = "'. JText::_("Loading").'...";
					itemSelectedCorePlace(val, "place", val, sel, formTo);
					showAddPlace("rest_tab_plc");						
				}
			}
		} 
		
		function SetYearListPlace(val, sel)
		{
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'plcForm').';
			var objSel = form.till;
			objSel.options.length = 0;			
			objSel.options[0] = new Option("'.JText::_('-- select from list --').'", true, true);
			var tmp = 1;
			if(val == 0) val = '.(date("Y")-70).';
			for(var i='.date("Y").'; i>=val; i-- )
			{
				if(sel && sel==i)
					objSel.options[tmp] = new Option(i, i, true, true);
				else
					objSel.options[tmp] = new Option(i, i);
				tmp++;
			}
		}
		
		function showAddPlace(id)
		{
			if(d.getElementById(id).style.display=="none")
				d.getElementById(id).style.display="block";			
		}
		function hideAddPlace(id)
		{
			if(d.getElementById(id).style.display=="block")
				d.getElementById(id).style.display="none";
		}
		
		function RecordExistErrorPlace(id, val)
		{
			var t=0;
			val = val.toLowerCase();
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'plcForm').';
			for(var i=0; i<form.elements[id].options.length; i++ )
			{
			var opt = form.elements[id].options[i].value.toLowerCase();
				if(opt == val)
				t++;
			}
			if(t>0){
				id = id.toUpperCase();
				val= val.toUpperCase();
				idUp = id.toUpperCase();
				valUp= val.toUpperCase();
				alert(idUp+" \""+valUp+"\"'. JText::_("is already exists").'");
			} else{
				addPlaceOption(id, val, val);		
			}
		}
		
		function enablePlace(id)
		{
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'plcForm').';
			form.elements[id].disabled = false;
		}
		
		function disablePlace(id)
		{
			form.elements[id].disabled = true;
		}
		
		function validateFormPlace()
		{
			var form = d.'.(JRequest::getVar('view') == 'customlist' ? 'adminForm' : 'plcForm').';
				if( form.country.value<=0 ) {
	             alert( "'.JText::_("You need to select").' "+"\''.JText::_("Country").'\'" );
	            } else if ( form.region.value<=0 ) {
	              alert( "'.JText::_("You need to select").' "+"\''. JText::_("Region").'\'" );
	            } else if ( form.city.value<=0  ) {
	              alert( "'.JText::_("You need to select").' "+"\''. JText::_("City").'\'" );
	            } else if ( form.place.value<=0  ) {
	              alert( "'.JText::_("You need to select").' "+"\''. JText::_("Place").'\'" );
	            } else if ( d.getElementById("living_tab_plc").style.display=="block" && form.living.value<=0) {
	              	alert( "'.JText::_("You need to select").' "+"\''. JText::_("Street / District").'\'" );
	            } else if ( d.getElementById("rest_tab_plc").style.display=="block" && form.rest.value<=0) {
	            	alert( "'.JText::_("You need to select").' "+"\''. JText::_("Name").'\'" );
	            } else if ( form.begin.value<=0  ) {
	              alert( "'.JText::_("You need to select").' "+"\''. JText::_("Begin").'\'" );
	            } else {
	            	if ( form.begin.value>form.till.value && form.till.value>0 ) {
		              alert( "\''.JText::_("Till").'\' "+"'.JText::_("couldn't be less than").' "+"\''.JText::_("Begin").'\'");
		            } else{
		             form.submit();
					}
				} 
		}
		</script>';
		return $script;
	}

	function GenListCore($field, $parent_val, $selected, $disabled = false, $formTo)
	{
		$db = &JFactory::getDBO();
		switch($field)
		{
			case 'country':
				$sql = "SELECT * FROM #__community_plg_edu_country ORDER BY name";
				$db->setQuery($sql);
				$result = $db->loadObjectList();
				$next = 'region';
				break;
			case 'region':
				$sql = "SELECT * FROM #__community_plg_edu_region WHERE country_id='$parent_val' ORDER BY name";
				$db->setQuery($sql);
				$result = $db->loadObjectList();
				$next = 'city';
				break;
			case 'city':
				$sql = "SELECT * FROM #__community_plg_edu_city WHERE region_id='$parent_val' ORDER BY name";
				$db->setQuery($sql);
				$result = $db->loadObjectList();
				$next = 'place';
				break;
			case 'living':
				$result = array();
				if($parent_val!='')
				{
					$parent = explode(".", $parent_val);
					if($selected!='')
					$disabled  = 0;
					$sql = "SELECT DISTINCT(address) as name FROM #__community_plg_places WHERE place='$parent[0]' AND city_id='$parent[1]' GROUP BY address";
					$db->setQuery($sql);
					$result = $db->loadObjectList();
				}
				$next = 'house';
				break;
			case 'rest':
				$result = array();
				if($parent_val!='')
				{
					$parent = explode(".", $parent_val);
					if($selected!='')
					$disabled  = 0;
					$sql = "SELECT DISTINCT(address) as name FROM #__community_plg_places WHERE place='$parent[0]' AND city_id='$parent[1]' GROUP BY address";
					$db->setQuery($sql);
					$result = $db->loadObjectList();
				}
				$next = '';
				break;
			case 'house':
				$result = array();
				if($parent_val!='')
				{
					$parent = explode(".", $parent_val);
					if($selected!='')
					$disabled  = 0;
					$sql = "SELECT DISTINCT(house) as name FROM #__community_plg_places WHERE address='$parent[0]' AND city_id='$parent[1]' GROUP BY house";
					$db->setQuery($sql);
					$result = $db->loadObjectList();
				}
				$next = '';
				break;
		}
		$opt = array();$out = array();
		$opt[] = JHTML::_('select.option', 0, JText::_("-- select from list --"));
		if(count($result)>0)
		{
			foreach ($result as $val)
			$opt[] = JHTML::_('select.option', (isset($val->id) ? $val->id : $val->name), ucwords(str_replace('`', '"',$val->name)));//ucwords(str_replace('`', '"',$val->name))
		}
		if($formTo!='search')
		$opt[] = JHTML::_('select.option', -1, JText::_("Other"));

		$out[] = JHTML::_("select.genericlist", $opt, $field, "class='inputbox' style='width: 100%;'
		onChange='itemSelectedCorePlace(this.value, \"".$field."\", \"".$next."\", \"".$selected."\", \"".$formTo."\")'
		".($disabled ? " disabled" : ""), 'value', 'text', $selected);
		return implode($out);
	}

	function GenListYear($field, $selected = '')
	{
		$opt = array();
		$opt[] = JHTML::_('select.option', 0, JText::_("-- select from list --"));
		for ($i=date("Y"); $i>=date("Y")-70; $i--)
		{
			$opt[] = JHTML::_('select.option', $i, $i);
		}
		$onchange = ($field == 'begin') ? 'onChange=\'SetYearListPlace(this.value, "'.$selected.'");\'' : '';
		$out[] = JHTML::_("select.genericlist", $opt, $field, "class='inputbox' ".$onchange, 'value', 'text', $selected);
		return implode($out);
	}

	function GenListMonth($field, $selected = '')
	{
		$month = array(JText::_("january"),JText::_("febrary"),JText::_("march"),JText::_("april"),
		JText::_("may"),JText::_("june"),JText::_("july"),JText::_("august"),JText::_("september"),
		JText::_("october"),JText::_("november"),JText::_("december"));

		$opt = array();
		$opt[] = JHTML::_('select.option', 0, JText::_("-- select from list --"));
		for ($i=0; $i<12; $i++)
		{
			$opt[] = JHTML::_('select.option', $i+1, $month[$i]);
		}
		$out[] = JHTML::_("select.genericlist", $opt, $field, "class='inputbox' ", 'value', 'text', $selected);
		return implode($out);
	}

	function getUserPlacesData()
	{
		$db     = &JFactory::getDBO();
		$user 	= JFactory::getUser();

		$month = array(JText::_("january"),JText::_("febrary"),JText::_("march"),JText::_("april"),
		JText::_("may"),JText::_("june"),JText::_("july"),JText::_("august"),JText::_("september"),
		JText::_("october"),JText::_("november"),JText::_("december"));

		$itemId 			= $this->params->get('item_itemid');

		$id = (JRequest::getVar('user_id')) ? JRequest::getVar('user_id') : $user->get('id');
		$out_text = '';
		$sql = "SELECT
				plc.*, UCASE(plc.address) as uaddress, 
				REPLACE(cnt.name, LEFT(cnt.name, 1), UCASE(LEFT(cnt.name, 1))) AS country, 
				REPLACE(r.name, LEFT(r.name, 1), UCASE(LEFT(r.name, 1))) AS region, 
				REPLACE(ct.name, LEFT(ct.name, 1), UCASE(LEFT(ct.name, 1))) AS city 
				FROM #__community_plg_places plc 
				JOIN #__community_plg_edu_country cnt ON plc.country_id=cnt.id
				JOIN #__community_plg_edu_region r ON plc.region_id=r.id
				JOIN #__community_plg_edu_city ct ON plc.city_id=ct.id
				WHERE plc.user_id='".$id."'
				ORDER BY plc.begin";
		$db->setQuery($sql);
		$result = $db->loadObjectList();
		if($result)
		{
			foreach($result as $val)
			{
				$remove_link = '';
				if($user->get('id')>0 && ($user->get('id')==$val->user_id || $user->get('gid')==25))
				{
					$this->uri->setVar( 'plc_remove', $val->id );
					$remove_link = '<a class="removeLink"
						onClick=\' if(confirm("'.JText::_('Remove item?').'")) document.location.replace("'.JRoute::_( $this->uri->toString() ).'");\'><img 
						src="'.JURI::root().'plugins/community/plc_images/remove.png" alt="'.JText::_('Remove').'"></a>';
					$this->uri->delVar('plc_remove');
				}
				$byCountry =  array('country'=>$val->country_id);
				$numByCountry = $this->GetUserData($db, $byCountry, 'num');
				$numByCountryLink = 'index.php?option=com_community&view=customlist&client=user_places&search=advanced&country='.$val->country_id;

				$byRegion =  array_merge($byCountry, array('region'=>$val->region_id));
				$numByRegion = $this->GetUserData($db, $byRegion, 'num');
				$numByRegionLink = $numByCountryLink.'&region='.$val->region_id;

				$byCity = array_merge($byRegion, array('city'=>$val->city_id));
				$numByCity = $this->GetUserData($db, $byCity, 'num');
				$numByCityLink = $numByRegionLink.'&city='.$val->city_id;

				$byAddress= array_merge($byCity, array('place'=>$val->place, $val->place=>$val->address));
				$numByAddress = $this->GetUserData($db, $byAddress, 'num');
				$numByAddressLink = 'index.php?option=com_community&view=customlist&client=user_places&search=advanced';
				foreach($byAddress as $var=>$value)
				{
					$numByAddressLink .= '&'.$var.'='.$value;
				}

				$byHouse= array_merge($byAddress, array('house'=>$val->house));
				$numByHouse = $this->GetUserData($db, $byHouse, 'num');
				$numByHouseLink = $numByAddressLink.'&house='.$val->house;


				$byBegin= array_merge($byAddress, array("begin" => $val->begin, "till" => $val->till));
				$numByBegin = $this->GetUserData($db, $byBegin, 'num');
				$numByBeginLink = $numByAddressLink.'&begin='.$val->begin.'&till='.$val->till;

				$this->uri->delVar('Itemid');
				$out_text .= '
				<table width="100%" border="0" cellspacing="0" cellpadding="0" class="userPlaces">
					<tr valign="top">
						<td width="150px">
								<b>'.JText::_("Place of")." ".JText::_($val->place).':</b>
						</td>
						<td width="80%">
							<b>'.(($val->house!='') ? $val->house.'</b>(<a href="'.$numByHouseLink.'">'.$numByHouse.'</a>), <b>' : '')
							.str_replace('`', '"', $val->uaddress).'</b>(<a href="'.$numByAddressLink.'">'.$numByAddress.'</a>)
						</td>
						<td rowspan="4">'.$remove_link.'</td>
					</tr>
					<tr>
						<td><b>'.JText::_("Location").':</b></td>
						<td>'.ucwords($val->country).
						'(<a href="'.$numByCountryLink.'">'.$numByCountry.'</a>)'
						.', '.ucwords($val->region).
						'(<a href="'.$numByRegionLink.'">'.$numByRegion.'</a>)'
						.', '.ucwords($val->city).
						'(<a href="'.$numByCityLink.'">'.$numByCity.'</a>)</td>
					</tr>
					<tr>
						<td><b>'.JText::_("Period").':</b></td>
						<td>'.$val->begin
						.( $val->till ? ' - '.$val->till : (($val->place == 'living') ? " - ".JText::_("Nowadays") : '') ).'</td>
					</tr>
					'.
						(($val->additional != '') ?
					'<tr>
						<td><b>'.JText::_("Additional").':</b></td>
						<td>'.$val->additional.'</td>
					</tr>
					' : "")
						.'
					<tr>
						<td>
							<a href="'.$numByBeginLink.'">
							'.( ($val->place == 'living') ? JText::_("Find neighbors") : JText::_("Find people") ).'</a> ('.$numByBegin.')
						</td>
						<td></td>
					</tr>
					';
						$out_text .= '
				<tr><td colspan="3" height="5px"></td></tr>
				</table><br>';			
			}
		}
		return $out_text;
	}

	function removeRecord( &$db , $id, $user_id)
	{
		global $mainframe;
		$this->uri          = &JFactory::getURI();
		$this->uri->delVar('plc_remove');

		$db->setQuery("SELECT user_id FROM #__community_plg_places WHERE id = '$id'");
		$owner_id = $db->loadResult();
		$db->setQuery("SELECT gid FROM #__users WHERE id = '$user_id'");
		$userGroup = $db->loadResult();
		if($user_id==$owner_id || $userGroup==25)
		{
			$db->setQuery( 'DELETE FROM #__community_plg_places WHERE id = '.$id );
			$db->query();
		}
		$mainframe->redirect($this->uri->toString(), JText::_('Place is removed'), 'Error');
	}

	function AddRecord( &$db, $user_id )
	{
		global $mainframe;
		$this->uri = &JFactory::getURI();
		$this->uri->delVar('task');
		$itemId	= $this->params->get('item_itemid');
		$this->uri->setVar('Itemid', $itemId);
		$core =$_POST;
		$core['user_id'] = $user_id;
		if($this->GetUserData($db, $core, ''))
		$mainframe->redirect($this->uri->toString(), JText::_('Record already exists'));
		$core['rest'] = str_replace('"', "`",$core['rest']);
		$core['rest'] = str_replace("'", "`",$core['rest']);
		$core['living'] = str_replace('"', "`",$core['living']);
		$core['living'] = str_replace("'", "`",$core['living']);
		$sql = "INSERT INTO #__community_plg_places
		VALUES ('','$user_id', '".$core['country']."', '".$core['region']."','".$core['city']."',
			'".$core['begin']."','".$core['till']."', '".$core['place']."',
			NOW(), '".(($core['place']=='living') ? $core['living'] : $core['rest'])."',
			'".(($core['place']=='living') ? $core['house'] : "")."', '".$core['additional']."')";				
		$db->setQuery( $sql);
		$db->query();
		$mainframe->redirect($this->uri->toString(), JText::_('Record is added'));
	}

	function onCustomUserList($client, $limitstart, $limit)
	{
		if ($client != 'user_places') { return; }
		global $mainframe;
		$db = &JFactory::getDBO();
		$this->uri          = &JFactory::getURI();
		$itemId 			= $this->params->get('item_itemid');
		//=========================
		JRequest::setVar('customlist_tmpl', $this->params->get('template', 'default'));
		$sel = $_GET;
		$out_form = '
			<style>		
			.plc_table {border: 1px solid #ddd;}
			.hidden {display: none;}
			</style>';
		$out_form .= $this->GenJScript();

		$out_form .= '
		<a href="javascript:void(0);" onClick="plc_showPlcForm()" name="write">Advanced search</a>
			<div id="plc" style="display: none; visibility: hidden;">
			';
		$out_form .= '
			<form action="'.$this->uri->toString().'" method="GET" name="plcForm">
			<table width="100%" class="plc_table" cellpadding="2">';
		$out_form .= '
			<input type="hidden" name="option" value="com_community">
			<input type="hidden" name="view" value="customlist">
			<input type="hidden" name="client" value="user_places">
			<input type="hidden" name="search" value="advanced">';
		$out_form .= $this->GenForm( 'search', $sel );

		$out_form .= '
			<tr>
				<td></td>
				<td>
					<input type="submit" value="'.JText::_("Search").'" class="button"">
				</td>
			</tr>
		</table><br><br>
		</form>
		</div><br>';

		$out_form .= '
			<script language="JavaScript">';
		if($sel['country']>0){
			$out_form .= 'd.getElementById("country").value = "'.$sel['country'].'";';
			$out_form .= 'itemSelectedCorePlace("'.$sel['country'].'", "country", "region", "'.(isset($sel['region']) ? $sel['region'] :'').'", "search");
			';	
		}
		if(isset($sel['region']))
		$out_form .= 'itemSelectedCorePlace("'.$sel['region'].'", "region", "city", "'.(isset($sel['city']) ? $sel['city'] :'').'", "search");
			';
		if(isset($sel['city']))
		$out_form .= 'itemSelectedCorePlace("'.$sel['city'].'", "city", "place", "'.( isset($sel['place']) ? $sel['place'] : '') .'", "search");
			';
		if(isset($sel['place']))
		$out_form .= 'setTimeout("ShowAddFieldsPlace(\"'.$sel['place'].'\", \"'.(isset($sel['living']) ? $sel['living']: $sel['rest'] ).'\", \"search\");", 1500);
			'.(isset($sel['living']) ? 'itemSelectedCorePlace(\"'.$sel['living'].'\", \"living\", \"house\", \"'.( isset($sel['house']) ? $sel['house'] : '' ).'\", \"search\");' : '' );		
		if(isset($sel['begin']))
		$out_form .= '
			SetYearListPlace("'.$sel['begin'].'", "'.$sel['till'].'");
			';
		$out_form .= '
		</script>';				

		$users = $this->GetUserData($db, $sel, '', $limitstart, $limit);
		$total = $this->GetUserData($db, $sel, 'num');
		$out_form .= "<br><b>".JText::_('Number of found users').": ".$total."</b><br>";

		if(count($users)>0)
		{
			$month = array(JText::_("january"),JText::_("febrary"),JText::_("march"),JText::_("april"),
			JText::_("may"),JText::_("june"),JText::_("july"),JText::_("august"),JText::_("september"),
			JText::_("october"),JText::_("november"),JText::_("december"));

			$this->uri->setVar( 'Itemid', $itemId );
				
			for($i = 0; $i < count($users); $i++)
			{
				$users[$i]->id = $users[$i]->user_id;
				$users[$i]->custom_data = '
				<table width="100%" border="0" cellspacing="0" cellpadding="0" class="userPlaces">
					<tr valign="top">
						<td width="150px">
								<b>'.JText::_("Place of").' '.JText::_($users[$i]->place).':</b>
						</td>
						<td width="80%">
						<b>
						'.( ($users[$i]->house!='') ? $users[$i]->house.', ' : '' )
							.str_replace('`', '"',$users[$i]->uaddress).'</b>
						</td>
					</tr>
					<tr>
						<td><b>'.JText::_("Period").':</b></td>
						<td>'.$users[$i]->begin
				.( $users[$i]->till ? ' - '.$users[$i]->till : ( ($users[$i]->place == 'living')? " - ".JText::_("Nowadays") : '' )).'</td>
					</tr>
				</table>';
			}
		}
		$return = new StdClass();

		$return->page_title = JText::_('User Places');
		$return->description = &$out_form;
		$return->total = $total;
		$return->users = &$users;

		//=========================
		return $return;
	}

	function GetUserData(&$db, $var = array(), $return, $limitstart = false, $limit = false)
	{
		$sql = "SELECT u.id, u.username, plc.*, UCASE(plc.address) as uaddress
			FROM #__community_plg_places plc
			JOIN #__users u ON plc.user_id=u.id
			";
		$where = array();
		if(isset($var['country']) && $var['country']>0) $where[]= " plc.country_id='".$var['country']."'" ;
		if(isset($var['region']) && $var['region']>0)$where[]= " plc.region_id='".$var['region']."'";
		if(isset($var['city']) && $var['city']>0) $where[]= " plc.city_id='".$var['city']."'";
		if(isset($var['place']) && $var['place']!='0')$where[]= " plc.place='".$var['place']."'";
		if(isset($var['living']) && $var['living']!='0')$where[]= " plc.address	='".$var['living']."'";
		if(isset($var['house']) && $var['house']!='0')$where[]= " plc.house='".$var['house']."'";
		if(isset($var['rest']) && $var['rest']!='0')$where[]= " plc.address='".$var['rest']."'";
		if(isset($var['begin']) && $var['begin']>0)$where[]= " (plc.begin>='".$var['begin']."' OR plc.till>='".$var['begin']."')";
		if(isset($var['till']) && $var['till'] > 0)$where[] = " plc.begin <= '".$var['till']."'";
		if(isset($var['user_id']) &&  $var['user_id']>0) $where[] = " plc.user_id = '".$var['user_id']."'";

		if(count($where)>0)
		{
			$sql .= " WHERE ". implode(" AND ", $where);
		}
		$sql .= " GROUP BY plc.id ORDER BY plc.ctime";
		if($limit)
		$sql .= " LIMIT $limitstart, $limit";

		$db->setQuery( $sql);
		//echo $db->_sql."<br><br>";
		$users = $db->loadObjectList();
		if($return=='num')
		return count($users);
		return $users;
	}
}

?>